#ifndef MY_ATK_OBJECT_FACTORY_H
#define MY_ATK_OBJECT_FACTORY_H

#include <atk/atk.h>

//factory
#define MY_TYPE_ATK_OBJECT_FACTORY             (my_atk_object_factory_get_type ())
#define MY_ATK_OBJECT_FACTORY(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), MY_TYPE_ATK_OBJECT_FACTORY, MyAtkObjectFactory))
#define MY_ATK_OBJECT_FACTORY_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), MY_TYPE_ATK_OBJECT_FACTORY, MyAtkObjectFactoryClass))
#define MY_IS_ATK_OBJECT_FACTORY(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MY_TYPE_ATK_OBJECT_FACTORY))
#define MY_IS_ATK_OBJECT_FACTORY_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), MY_TYPE_ATK_OBJECT_FACTORY))
#define MY_ATK_OBJECT_FACTORY_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_CLASS ((inst), MY_TYPE_ATK_OBJECT_FACTORY, MyAtkObjectFactoryClass))


typedef struct _MyAtkObjectFactory MyAtkObjectFactory;
typedef struct _MyAtkObjectFactoryClass MyAtkObjectFactoryClass;

struct _MyAtkObjectFactory
{
    AtkObjectFactory parent;
};
struct _MyAtkObjectFactoryClass
{
    AtkObjectFactoryClass parent;
};

GType my_atk_object_factory_get_type(); 

//returned object
#define MY_TYPE_ATK_OBJECT             (my_atk_object_get_type ())
#define MY_ATK_OBJECT(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), MY_TYPE_ATK_OBJECT, MyAtkObject))
#define MY_ATK_OBJECT_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), MY_TYPE_ATK_OBJECT, MyAtkObjectClass))
#define MY_IS_ATK_OBJECT(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MY_TYPE_ATK_OBJECT))
#define MY_IS_ATK_OBJECT_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), MY_TYPE_ATK_OBJECT))
#define MY_ATK_OBJECT_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_CLASS ((inst), MY_TYPE_ATK_OBJECT, MyAtkObjectClass))


typedef struct _MyAtkObject MyAtkObject;
typedef struct _MyAtkObjectClass MyAtkObjectClass;

struct _MyAtkObject
{
    AtkObject parent;
    GObject *obj;
};
struct _MyAtkObjectClass
{
    AtkObjectClass parent;
};

GType my_atk_object_get_type(); 

//Implmentation
//virtual functions
AtkObject* my_atk_object_factory_create_accessible(GObject *obj)
{
    g_return_val_if_fail(G_IS_OBJECT(obj), NULL);
    MyAtkObject* result = g_object_new(MY_TYPE_ATK_OBJECT,NULL);
    result->obj = obj;
    return ATK_OBJECT(result);
}

GType my_atk_object_factory_get_accessible_type(void)
{
    return MY_TYPE_ATK_OBJECT;
}

void my_atk_object_factory_invalidate(AtkObjectFactory *factory)
{
    return;
}
//MyAtkObjectFactory
void my_atk_object_factory_class_init(gpointer g_class,gpointer g_data)
{
    AtkObjectFactoryClass *parent_class = ATK_OBJECT_FACTORY_CLASS(g_class);
    
    parent_class->create_accessible = my_atk_object_factory_create_accessible;
    parent_class->get_accessible_type = my_atk_object_factory_get_accessible_type;
    parent_class->invalidate = my_atk_object_factory_invalidate;
}

GType my_atk_object_factory_get_type(void)
{
    static GType type = 0;
    if(type == 0)
    {
        static const GTypeInfo typeinfo = {
            sizeof(MyAtkObjectFactoryClass),
            NULL, /*base_init */
            NULL, /*base_finalize */
            my_atk_object_factory_class_init,/*class_init*/
            NULL, /*class_finalize*/
            NULL,/*class_data*/
            sizeof(MyAtkObjectFactory),
            0, /*n_prealloc*/
            NULL/* instance_init*/
        };
        type = g_type_register_static(ATK_TYPE_OBJECT_FACTORY,"MyAtkObjectFactory",&typeinfo,0);
    }
    return type;
}

//MyAtkObject
void my_atk_object_instance_init(GTypeInstance *instance, gpointer g_class)
{
    ((MyAtkObject*)instance)->obj = NULL;
}
GType my_atk_object_get_type(void)
{
    static GType type = 0;
    if(type == 0)
    {
        static const GTypeInfo typeinfo = {
            sizeof(MyAtkObjectClass),
            NULL, /*base_init */
            NULL, /*base_finalize */
            NULL, /*class_init*/
            NULL, /*class_finalize*/
            NULL, /*class_data*/
            sizeof(MyAtkObject),
            0, /*n_prealloc*/
            my_atk_object_instance_init/* instance_init*/
        };
        type = g_type_register_static(ATK_TYPE_OBJECT,"MyAtkObject",&typeinfo,0);
    }
    return type;
}
//***********************************************************************************

/*
 * Another factory
 * (but really differs from MyAtkObjectFactory only by type and type of returned accessible)
 */

#define MY_TYPE_ATK_OBJECT_FACTORY1             (my_atk_object_factory1_get_type ())
#define MY_ATK_OBJECT_FACTORY1(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), MY_TYPE_ATK_OBJECT_FACTORY1, MyAtkObjectFactory1))
#define MY_ATK_OBJECT_FACTORY1_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), MY_TYPE_ATK_OBJECT_FACTORY1, MyAtkObjectFactory1Class))
#define MY_IS_ATK_OBJECT_FACTORY1(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MY_TYPE_ATK_OBJECT_FACTORY1))
#define MY_IS_ATK_OBJECT_FACTORY1_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), MY_TYPE_ATK_OBJECT_FACTORY1))
#define MY_ATK_OBJECT_FACTORY1_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_CLASS ((inst), MY_TYPE_ATK_OBJECT_FACTORY1, MyAtkObjectFactory1Class))

typedef struct _MyAtkObjectFactory1 MyAtkObjectFactory1;
typedef struct _MyAtkObjectFactory1Class MyAtkObjectFactory1Class;

struct _MyAtkObjectFactory1
{
    MyAtkObjectFactory parent;
};
struct _MyAtkObjectFactory1Class
{
    MyAtkObjectFactoryClass parent;
};

GType my_atk_object_factory1_get_type(); 

//returned object
#define MY_TYPE_ATK_OBJECT1             (my_atk_object1_get_type ())
#define MY_ATK_OBJECT1(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), MY_TYPE_ATK_OBJECT1, MyAtkObject1))
#define MY_ATK_OBJECT1_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), MY_TYPE_ATK_OBJECT1, MyAtkObject1Class))
#define MY_IS_ATK_OBJECT1(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MY_TYPE_ATK_OBJECT1))
#define MY_IS_ATK_OBJECT1_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), MY_TYPE_ATK_OBJECT1))
#define MY_ATK_OBJECT1_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_CLASS ((inst), MY_TYPE_ATK_OBJECT1, MyAtkObject1Class))


typedef struct _MyAtkObject1 MyAtkObject1;
typedef struct _MyAtkObject1Class MyAtkObject1Class;

struct _MyAtkObject1
{
    MyAtkObject parent;
};
struct _MyAtkObject1Class
{
    MyAtkObjectClass parent;
};

GType my_atk_object1_get_type(); 

//Implmentation
//virtual function
AtkObject* my_atk_object_factory1_create_accessible(GObject *obj)
{
    g_return_val_if_fail(G_IS_OBJECT(obj), NULL);
    MyAtkObject1* result = g_object_new(MY_TYPE_ATK_OBJECT1,NULL);
    ((MyAtkObject*)result)->obj = obj;
    return ATK_OBJECT(result);
}
GType my_atk_object_factory1_get_accessible_type(void)
{
    return MY_TYPE_ATK_OBJECT1;
}

void my_atk_object_factory1_class_init(gpointer g_class,gpointer g_data)
{
    AtkObjectFactoryClass *parent_class = ATK_OBJECT_FACTORY_CLASS(g_class);
    
    parent_class->create_accessible = my_atk_object_factory1_create_accessible;
    parent_class->get_accessible_type = my_atk_object_factory1_get_accessible_type;
}

GType my_atk_object_factory1_get_type(void)
{
    static GType type = 0;
    if(type == 0)
    {
        static const GTypeInfo typeinfo = {
            sizeof(MyAtkObjectFactory1Class),
            NULL, /*base_init */
            NULL, /*base_finalize */
            my_atk_object_factory1_class_init,/*class_init*/
            NULL, /*class_finalize*/
            NULL,/*class_data*/
            sizeof(MyAtkObjectFactory1),
            0, /*n_prealloc*/
            NULL/* instance_init*/
        };
        type = g_type_register_static(MY_TYPE_ATK_OBJECT_FACTORY,"MyAtkObjectFactory1",&typeinfo,0);
    }
    return type;
}

//MyAtkObject1
GType my_atk_object1_get_type(void)
{
    static GType type = 0;
    if(type == 0)
    {
        static const GTypeInfo typeinfo = {
            sizeof(MyAtkObject1Class),
            NULL, /*base_init */
            NULL, /*base_finalize */
            NULL,/*class_init*/
            NULL, /*class_finalize*/
            NULL,/*class_data*/
            sizeof(MyAtkObject1),
            0, /*n_prealloc*/
            NULL/*instance_init*/
        };
        type = g_type_register_static(MY_TYPE_ATK_OBJECT,"MyAtkObject1",&typeinfo,0);
    }
    return type;
}

#endif /*MY_ATK_OBJECT_FACTORY_H*/
