#!/bin/sh

# Installs or uninstalls (if -u option is specified) custom pixbuf loader
# Place this script to the directory where the loader (checkboard.so) is.

# Get the directory where this script resides.
WORK_DIR=$(cd `dirname $0` && pwd) 
cd ${WORK_DIR}

PATH=/opt/gnome/bin:$PATH

if [ -z ${GDK_PIXBUF_MODULE_FILE} ]
then
    if [ ! -d "${SYSCONFDIR}/gtk-2.0" ]
    then
        SYSCONFDIR=/etc
        if [ ! -d "${SYSCONFDIR}/gtk-2.0" ]  
        then
            SYSCONFDIR=/etc/opt/gnome
            if [ ! -d "${SYSCONFDIR}/gtk-2.0" ]  
            then
                echo "Unable to locate directory containing the .loaders file."
                exit 1
            fi
        fi
    fi

	GDK_PIXBUF_MODULE_FILE=${SYSCONFDIR}/gtk-2.0/gdk-pixbuf64.loaders
	if [ ! -e "${GDK_PIXBUF_MODULE_FILE}" ]
	then
		GDK_PIXBUF_MODULE_FILE=${SYSCONFDIR}/gtk-2.0/gdk-pixbuf.loaders
		if [ ! -e "${GDK_PIXBUF_MODULE_FILE}" ]
		then
			echo "Unable to locate the .loaders file in ${SYSCONFDIR}/gtk-2.0/"
            exit 1
		fi
	fi
fi  

echo "Updating the list of loaders in ${GDK_PIXBUF_MODULE_FILE}"

QL_CMD=gdk-pixbuf-query-loaders-64
which ${QL_CMD} >/dev/null 2>&1 
if [ $? -ne 0 ] 
then
	QL_CMD=gdk-pixbuf-query-loaders
fi 

if [ "$1" = '-u' ] 
then
#uninstall
    echo "Uninstalling custom pixbuf loader..."
    ${QL_CMD} > ${GDK_PIXBUF_MODULE_FILE}
else
#install
    echo "Installing custom pixbuf loader..."
    ${QL_CMD} checkboard.so >> ${GDK_PIXBUF_MODULE_FILE} 
fi
