#ifndef __ISPRAU_GLIB_THREADS_TEST__
#define __ISPRAU_GLIB_THREADS_TEST__


#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <sys/time.h>
#include <time.h>
#include <semaphore.h>

#include <glib.h>



#define VAR(function, name, tp_index)  _##function##_TP_##tp_index##_##name
#define FUNC(function, name, tp_index) __##function##_TP_##tp_index##_##name
#define TP_FUNC(function, tp_index) _##function##_TP_##tp_index##_



#define TIMED_WAIT(condition, seconds)\
  	int __tw_expired=0; struct timeval __tv;gettimeofday(&__tv, NULL);long __st_sec=__tv.tv_sec;\
	while(condition) {g_usleep(100);gettimeofday(&__tv, NULL);if((__tv.tv_sec - __st_sec)>seconds){ __tw_expired=1;break;}}

#define TIMED_WAIT_EXPIRED __tw_expired


#define TIMED_WAIT_2(condition, seconds)\
  	__tw_expired=0;gettimeofday(&__tv, NULL);__st_sec=__tv.tv_sec;\
	while(condition) {g_usleep(100);gettimeofday(&__tv, NULL);if((__tv.tv_sec - __st_sec)>seconds) { __tw_expired=1;break;}}



#define _DECLARE_G_SEMAPHORE(s_name) sem_t s_name;

#define _G_SUNLOCK(s_name)  sem_post(&s_name);

#define _G_STIMED_WAIT(seconds, s_name, exp_var, tumeout_st)\
	int exp_var=0;struct timespec tumeout_st;clock_gettime(CLOCK_REALTIME, &tumeout_st);tumeout_st.tv_sec += seconds;\
	if(sem_timedwait(&s_name, &tumeout_st) != 0){if(errno == ETIMEDOUT) exp_var=1;}

#define _G_STIMED_WAIT_2(seconds, s_name, exp_var, tumeout_st)\
	exp_var=0;clock_gettime(CLOCK_REALTIME, &tumeout_st);tumeout_st.tv_sec += seconds;\
	if(sem_timedwait(&s_name, &tumeout_st) != 0){if(errno == ETIMEDOUT) exp_var=1;}

#define _G_STIMED_WAIT_EXPIRED(exp_var) exp_var


#define DECLARE_G_SEMAPHORE 		_DECLARE_G_SEMAPHORE(_g_sem_)
#define G_SUNLOCK 					_G_SUNLOCK(_g_sem_)
#define G_STIMED_WAIT(seconds) 		_G_STIMED_WAIT(seconds, _g_sem_, __stw_expired, __stimeout)
#define G_STIMED_WAIT_2(seconds)	_G_STIMED_WAIT_2(seconds, _g_sem_, __stw_expired, __stimeout)
#define G_STIMED_WAIT_EXPIRED		_G_STIMED_WAIT_EXPIRED(__stw_expired)


#define DECLARE_G_SEMAPHORE_EX 		_DECLARE_G_SEMAPHORE(_g_sem_2)
#define G_SUNLOCK_EX 				_G_SUNLOCK(_g_sem_2)
#define G_STIMED_WAIT_EX(seconds) 	_G_STIMED_WAIT(seconds, _g_sem_2, __stw_expired_2, __stimeout_2)
#define G_STIMED_WAIT_2_EX(seconds)	_G_STIMED_WAIT_2(seconds, _g_sem_2, __stw_expired_2, __stimeout_2)
#define G_STIMED_WAIT_EXPIRED_EX	_G_STIMED_WAIT_EXPIRED(__stw_expired_2)

#define DECLARE_G_SEMAPHORE_EX_2 		_DECLARE_G_SEMAPHORE(_g_sem_3)
#define G_SUNLOCK_EX_2 					_G_SUNLOCK(_g_sem_3)
#define G_STIMED_WAIT_EX_2(seconds) 	_G_STIMED_WAIT(seconds, _g_sem_3, __stw_expired_3, __stimeout_3)
#define G_STIMED_WAIT_2_EX_2(seconds)	_G_STIMED_WAIT_2(seconds, _g_sem_3, __stw_expired_3, __stimeout_3)
#define G_STIMED_WAIT_EXPIRED_EX_2		_G_STIMED_WAIT_EXPIRED(__stw_expired_3)


DECLARE_G_SEMAPHORE
DECLARE_G_SEMAPHORE_EX
DECLARE_G_SEMAPHORE_EX_2



#endif

