#ifndef __ISPRAU_TET_MESSAGES__
#define __ISPRAU_TET_MESSAGES__

#include<stdarg.h>
#include<string.h>
#include<stdio.h>


#ifndef DISABLE_TET

    #define TET_INFO(message) tet_infoline(" INFO: " message "\n");

    #define TET_ERROR(message) tet_infoline(" ERROR: " message "\n");


//  #define TET_TP_FAIL(message) {TET_ERROR(message) tet_result(TET_FAIL); return;}

//  #define TET_TP_FAIL_STATUS(message, status) { TET_ERROR(message) tet_result(status); return; }

    #define TET_SUCCESS tet_result(TET_PASS);

    #ifndef DISABLE_DEBUG_MSG
        #define TET_DEBUG_MSG(message) tet_printf(" DEBUG: %s \n", message);
        #define TET_DEBUG(message,...) {char prefix[]="DEBUG: ";char* debugMessage = malloc(strlen(prefix) + strlen(message) + 1);debugMessage[0]='\0';\
         strcat(debugMessage, prefix);strcat(debugMessage, message);tet_printf(debugMessage, __VA_ARGS__); free(debugMessage);}

    #else
        #define TET_DEBUG_MSG(message)
        #define TET_DEBUG(message,...)
    #endif



#else


    #define TET_INFO(message) printf(" INFO: " message "\n");

    #define TET_ERROR(message) printf(" ERROR: " message "\n");


//  #define TET_TP_FAIL(message){ TET_ERROR(message) printf(" TET_FAIL"); return;}

//  #define TET_TP_FAIL_STATUS(message, status){ TET_ERROR(message) printf(status); return; }

    #define TET_SUCCESS printf(" TET_PASS\n");

    #ifndef DISABLE_DEBUG_MSG
        #define TET_DEBUG_MSG(message) printf(" DEBUG: %s \n", message);
        #define TET_DEBUG(message,...) {char prefix[]="DEBUG: ";char* debugMessage = malloc(strlen(prefix) + strlen(message) + 1);debugMessage[0]='\0';\
         strcat(debugMessage, prefix);strcat(debugMessage, message);printf(debugMessage, __VA_ARGS__); free(debugMessage);}
    #else
        #define TET_DEBUG_MSG(message)
        #define TET_DEBUG(message,...)
    #endif


#endif

#define UNRES(message, condition)\
        {if (!(condition)) { \
            TRACE("FAILED CHECK in %s, line %d \n comment: %s\n", __FILE__, __LINE__,  message); \
            ABORT_TEST_PURPOSE("Test purpose error.");\
        }} \

#define UNRES_ERR(g_error)\
        {if (g_error != NULL) { \
            TRACE("Error Reported in %s, line %d \n comment: [%d: %s]\n", __FILE__, __LINE__,  g_error->code, g_error->message); \
            g_error_free (g_error);\
            g_error = NULL;\
            ABORT_TEST_PURPOSE("Test purpose error.");\
        }} \



int _startup_failed = 0;

#define STARTUP_FAILED _startup_failed
#define SET_STARTUP_FAILED {_startup_failed=1;return;}
#define UNRES_IF_STARTUP_FAILED UNRES("Startup failed, aborting the test case.", !_startup_failed)

#endif





