#ifndef GTTP_COMMON_H_
#define GTTP_COMMON_H_

#include <glib.h>
#include <glib-object.h>

typedef struct _GTTPPluginImpl_CT{

    gboolean use_checklist;

    gint use_plugin_cc;
    gint unuse_plugin_cc;
    gint ctypei_cc;
    gint cifacei_cc;

    gpointer use_plugin_pplugin;

    gpointer unuse_plugin_pplugin;

    gpointer ctypei_pplugin;
    GType ctypei_pg_type;
    GTypeInfo* ctypei_pinfo;
    GTypeValueTable *ctypei_pvalue_table;

    gpointer cifacei_pplugin;
    GType cifacei_pinstance_type;
    GType cifacei_pinterface_type;
    GInterfaceInfo *cifacei_pinfo;


} GTTPPluginImpl_CT;



typedef struct _GTTPIMap_CT{

    gboolean use_checklist;

    gint base_init_call_count;
    gint exp_base_init_call_count;
    gboolean base_init_params_valid;
    GType base_init_p_exp_class_type[3];


    gint class_init_call_count;
    gboolean class_init_params_valid;
    gpointer class_init_p_exp_class;
    gpointer class_init_p_exp_class_data;

    gboolean init_call_order_valid;
    gboolean struct_zero_filled;

} GTTPIMap_CT;

typedef struct _GTTPFMap_CT{

    gboolean use_checklist;

    gint base_init_call_count;
    gint exp_base_init_call_count;
    gboolean base_init_params_valid;

    gint class_init_call_count;
    gint exp_class_init_call_count;
    gboolean class_init_params_valid;
    gpointer class_init_p_exp_class;
    gpointer class_init_p_exp_class_data;

    gboolean class_struct_zero_filled;
    gboolean init_call_order_valid;

    //This one is for 'base_init()' call order verification
    gboolean iface_init_call_order_valid;
    gpointer iface_base_init_call_p_g_class;

    //This section is for 'GInterfaceInfo.interface_init' call order verification
    gint class_iface_init_call_count;
    gboolean class_iface_init_call_order_valid;
    gpointer class_iface_init_p_exp_iface_data;
    gboolean class_iface_init_params_valid;


    gboolean icheck_call_order_valid;
    gint icheck_handler_1_call_count;
    gint icheck_handler_2_call_count;


    gpointer exp_g_iface;

} GTTPFMap_CT;


typedef struct _GTTPFSet_CT{

    gboolean use_checklist;

    gint base_init_call_count;
    gint exp_base_init_call_count;
    gboolean base_init_params_valid;

    gint class_init_call_count;
    gint exp_class_init_call_count;
    gboolean class_init_params_valid;
    gpointer class_init_p_exp_class;
    gpointer class_init_p_exp_class_data;

    gboolean class_struct_zero_filled;
    gboolean init_call_order_valid;
    gboolean instance_not_null;
    gboolean class_not_null;
    gboolean local_class_type_is_valid;
    gboolean local_instance_type_is_valid;
    GType expected_class_type;
    gboolean expected_class_type_is_valid;
    gboolean expected_instance_type_is_valid;
    gint instance_count;
	gboolean private_init_is_done;
} GTTPFSet_CT;


typedef struct _GTTPPointSet_CT{

    gboolean use_checklist;

    gint parent_base_init_call_count;
    gint exp_parent_base_init_call_count;
    GType parent_base_init_p_exp_class_type[3];
    gboolean parent_base_init_params_valid;

    gint parent_class_init_call_count;
    gint exp_parent_class_init_call_count;

    gint base_init_call_count;
    gint exp_base_init_call_count;
    gboolean base_init_params_valid;

    gint class_init_call_count;
    gint exp_class_init_call_count;
    gboolean class_init_params_valid;
    gpointer class_init_p_exp_class;
    gpointer class_init_p_exp_class_data;

    gboolean class_struct_common_copied;
    gboolean class_struct_zero_filled;
    gboolean init_call_order_valid;

} GTTPPointSet_CT;


typedef struct _GTTPPointList_CT{

    gboolean use_checklist;


    gint exp_base_init_call_count;

    gint exp_class_init_call_count;

    gboolean icheck_call_order_valid;
    gint icheck_handler_1_call_count;
    gint icheck_handler_2_call_count;

    gpointer exp_g_iface;

} GTTPPointList_CT;


typedef struct _GTTPTreeMap_CT{

    gboolean use_checklist;

    gint parent_base_init_call_count;
    gint exp_parent_base_init_call_count;
    GType parent_base_init_p_exp_class_type[3];
    gboolean parent_base_init_params_valid;

    gint parent_class_init_call_count;
    gint exp_parent_class_init_call_count;

    gint base_init_call_count;
    gint exp_base_init_call_count;
    gboolean base_init_params_valid;

    gint class_init_call_count;
    gint exp_class_init_call_count;
    gboolean class_init_params_valid;
    gpointer class_init_p_exp_class;
    gpointer class_init_p_exp_class_data;

    gboolean class_struct_common_copied;
    gboolean class_struct_zero_filled;
    gboolean init_call_order_valid;

    //This one is for 'base_init()' call order verification
    gboolean iface_init_call_order_valid;
    gpointer iface_base_init_call_p_g_class;

    //This section is for 'GInterfaceInfo.interface_init' call order verification
    gint class_iface_init_call_count;
    gboolean class_iface_init_call_order_valid;
    gpointer class_iface_init_p_exp_iface_data;
    gboolean class_iface_init_params_valid;


    gboolean icheck_call_order_valid;
    gint icheck_handler_1_call_count;
    gint icheck_handler_2_call_count;


    gpointer exp_g_iface;

} GTTPTreeMap_CT;

typedef struct _GTTPDynSet_CT{

    gboolean use_checklist;

    gint base_init_call_count;
    gint exp_base_init_call_count;
    gboolean base_init_params_valid;

    gint class_init_call_count;
    gint exp_class_init_call_count;
    gboolean class_init_params_valid;
    gpointer class_init_p_exp_class;
    gpointer class_init_p_exp_class_data;

    gboolean class_struct_common_copied;
    gboolean class_struct_zero_filled;
    gboolean init_call_order_valid;

    gint class_finalize_call_count;

} GTTPDynSet_CT;

typedef struct _GTTPDynList_CT{

    gboolean use_checklist;

    gint class_finalize_call_count;

} GTTPDynList_CT;

#define GTTPFSet01_CT GTTPFSet_CT
#define GTTPPointSet01_CT GTTPFSet_CT
#define GTTPPointList01_CT GTTPFSet_CT

extern GTTPPluginImpl_CT gttpplugin_ct;
extern GTTPIMap_CT gttpimap_ct;
extern GTTPFMap_CT gttpfmap_ct;
extern GTTPFSet_CT gttpfset_ct;
extern GTTPPointSet_CT gttppointset_ct;
extern GTTPPointList_CT gttppointlist_ct;
extern GTTPTreeMap_CT gttptreemap_ct;
extern GTTPDynSet_CT gttpdynset_ct;
extern GTTPDynList_CT gttpdynlist_ct;
extern GTTPFSet01_CT gttpfset01_ct;
extern GTTPPointSet01_CT gttppointset01_ct;
extern GTTPPointList01_CT gttppointlist01_ct;


#define SET_USED_CT(ct_name) ct_name.use_checklist = TRUE;
#define SET_UNUSED_CT(ct_name) ct_name.use_checklist = FALSE;
#define IS_USED_CT(ct_name) ct_name.use_checklist == TRUE
#define TEST_IF_USED(ct_name, expression) ct_name.use_checklist == TRUE && (expression)


#endif /*COMMON_H_*/

