#ifndef GTTPDYNLIST_H_
#define GTTPDYNLIST_H_


#include "gttp-common.h"
#include "gttp-idynlist.h"
#include "gttp-dynset.h"

/*
 * Proposed as a descendant of the GTTPPointSet class,
 * implementing GTTPIList interface.
 *
 */


#define GTTP_TYPE_DYNLIST       (gttp_type_dynlist_t)
#define GTTP_DYNLIST_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_DYNLIST, GTTPDynListClass))
#define GTTP_IS_DYNLIST_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_DYNLIST))

#define GTTP_DYNLIST(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_DYNLIST,  GTTPDynList))
#define GTTP_IS_DYNLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_DYNLIST))
#define GTTP_DYNLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_DYNLIST, GTTPDynListClass))


#define GTTP_TYPE_DYNLIST_NAME       "GTTPDynList"
#define GTTP_TYPE_DYNLIST_CLASS_INFO    dynlist_type_info
#define GTTP_TYPE_DYNLIST_IDYNLIST_IFACE_INFO dynlist_idynlist_iface_info


typedef struct _GTTPDynList GTTPDynList;
typedef struct _GTTPDynListClass GTTPDynListClass;

struct _GTTPDynList{
    GTTPDynSet parent_object;

};

struct _GTTPDynListClass{
    GTTPDynSetClass parent_class;

};


GType test_register_gttp_dynlist_type(GType parent_type,
                                     GType interface_type,
                                     GTypePlugin* plugin,
                                     const gchar* type_name,
                                     GTypeFlags type_flags,
                                     const gpointer class_data,
                                     const gpointer iface_data);

extern GType gttp_type_dynlist_t;
extern GTypeInfo dynlist_type_info;
extern GInterfaceInfo dynlist_idynlist_iface_info;


#endif /*GTTPDYNLIST_H_*/
