#ifndef GTTPFMAP_H_
#define GTTPFMAP_H_


#include <glib-object.h>

#include "gttp-imap.h"

/*
 *
 * Fundamental type, representing a map of objects.
 *
 * This will be registered with various fundamental and
 * type flags.
 *
 */
#define GTTP_TYPE_FMAP           (register_gttp_fmap_type())
#define GTTP_FMAP_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_FMAP, GTTPFMapClass))
#define GTTP_IS_FMAP_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_FMAP))

#define GTTP_FMAP(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_FMAP,  GTTPFMap))
#define GTTP_IS_FMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_FMAP))
#define GTTP_FMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_FMAP, GTTPFMapClass))


typedef struct _GTTPFMap    GTTPFMap;
typedef struct _GTTPFMapClass GTTPFMapClass;



#define FMAP_FIELD_PTR_INIT_VALUE 0x12AB
#define FMAP_FIELD_BOOL_INIT_VALUE 1
#define FMAP_FIELD_LONG_INIT_VALUE 56789


struct _GTTPFMap{
  GTypeInstance parent;

};


struct _GTTPFMapClass{
    GTypeClass parent_class;

//--------------------------------------------------------
    gpointer field_ptr;
    gboolean field_bool;
    glong field_long;
};


//Very specific type registration function, to register this fundamental type
// with different combination of flags.
GType register_gttp_fmap_type();
GType test_register_gttp_fmap_type( const gchar* type_name,
                                    GType imap_iface_type,
                                    GTypeFundamentalFlags fundamental_flags,
                                    GTypeFlags type_flags,
                                    const gpointer class_data, const gpointer imap_iface_data);




#endif /*GTTPFMAP_H_*/
