#ifndef GTTPREGTYPES_H_
#define GTTPREGTYPES_H_


#define FTYPE_INFO_STRUCT(prefix) prefix##_info
#define FTYPE_CLASS_STRUCT(prefix) prefix##Class
#define FTYPE_IFACE_STRUCT(prefix) prefix##Iface


//1. Non classed, non instantiable type
    GTypeInfo FTYPE_INFO_STRUCT(ninc) = {
        0,                           /* class_size */
        NULL,                        /* base_init */
        NULL,                        /* base_destroy */
        NULL,                        /* class_init */
        NULL,                        /* class_destroy */
        NULL,                        /* class_data */
        0,                           /* instance_size */
        0,                           /* n_preallocs */
        NULL,                        /* instance_init */
        NULL,                        /* value_table */
    };


//2.Classed, non instantiable type with empty init/finalize methods

    typedef struct FTYPE_CLASS_STRUCT(_GTTPNic) {
      GTypeClass parent;

    } FTYPE_CLASS_STRUCT(GTTPNic);

    GTypeInfo FTYPE_INFO_STRUCT(nic_e) = {
        sizeof(FTYPE_CLASS_STRUCT(GTTPNic)),   /* class_size */
        NULL,                        /* base_init */
        NULL,                        /* base_destroy */
        NULL,                        /* class_init */
        NULL,                        /* class_destroy */
        NULL,                        /* class_data */
        0,                           /* instance_size */
        0,                           /* n_preallocs */
        NULL,                        /* instance_init */
        NULL,                        /* value_table */
    };

//3.Classed, non instantiable type, based on interface, with empty init/finalize methods

    typedef struct FTYPE_IFACE_STRUCT(_GTTPNic) {
      GTypeInterface parent;

    } FTYPE_IFACE_STRUCT(GTTPNic);

    GTypeInfo FTYPE_INFO_STRUCT(inic_e) = {
        sizeof(FTYPE_IFACE_STRUCT(GTTPNic)),   /* class_size */
        NULL,                        /* base_init */
        NULL,                        /* base_destroy */
        NULL,                        /* class_init */
        NULL,                        /* class_destroy */
        NULL,                        /* class_data */
        0,                           /* instance_size */
        0,                           /* n_preallocs */
        NULL,                        /* instance_init */
        NULL,                        /* value_table */
    };

//4.Classed, instantiable type with empty init/finalize methods

    typedef struct FTYPE_CLASS_STRUCT(_GTTPIc) {
      GTypeClass parent_class;

    } FTYPE_CLASS_STRUCT(GTTPIc);

    typedef struct _GTTPIc{
        GTypeInstance parent;
    } GTTPIc;

    GTypeInfo FTYPE_INFO_STRUCT(ic_e) = {
        sizeof(FTYPE_CLASS_STRUCT(GTTPNic)),   /* class_size */
        NULL,                        /* base_init */
        NULL,                        /* base_destroy */
        NULL,                        /* class_init */
        NULL,                        /* class_destroy */
        NULL,                        /* class_data */
        sizeof(GTTPIc),              /* instance_size */
        0,                           /* n_preallocs */
        NULL,                        /* instance_init */
        NULL,                        /* value_table */
    };



#endif /*GTTPREGTYPES_H_*/
