#ifndef GTTPFSET_H_
#define GTTPFSET_H_


#include <glib-object.h>

#include "gttp-common.h"

/*
 *
 * Fundamental type, representing a set of objects.
 *
 * This will be registered with various fundamental and
 * type flags.
 *
 */
#define GTTP_TYPE_FSET           (register_gttp_fset_type(TRUE))
#define GTTP_TYPE_FSET_NO_INIT           (register_gttp_fset_type(FALSE))
#define GTTP_FSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_FSET, GTTPFSetClass))
#define GTTP_IS_FSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_FSET))

#define GTTP_FSET(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_FSET,  GTTPFSet))
#define GTTP_IS_FSET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_FSET))
#define GTTP_FSET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_FSET, GTTPFSetClass))

typedef struct _GTTPFSetPrivate GTTPFSetPrivate;

#define GTTP_FSET_GET_FSET_PRIVATE(o) \
 (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTTP_TYPE_FSET, GTTPFSetPrivate))

struct _GTTPFSetPrivate {
 int member;
};




#define FSET_FIELD_PTR_INIT_VALUE 0x1EC3
#define FSET_FIELD_DBL_INIT_VALUE 1
#define FSET_FIELD_ICOUNT_INIT_VALUE 0

#define GTTP_TYPE_FSET_NAME          "GTTPFSet"


typedef struct _GTTPFSet    GTTPFSet;
typedef struct _GTTPFSetClass GTTPFSetClass;


struct _GTTPFSet{
  GTypeInstance parent;

//Synthetic fields
  gint element_count;
  gpointer* elements;

// Diagnosing fields
  int instance_id;
};


struct _GTTPFSetClass{
    GTypeClass parent_class;




//--------------------------------------------------------

    void (*add)(GTTPFSet* set_object, gpointer element);
    void (*remove)(GTTPFSet* set_object, gpointer element);
    gint (*size)(GTTPFSet* set_object);
    int (*get_instance_count)();
   	int (*get_instance_id)(GTTPFSet* self);
	GTTPFSetPrivate* (*gttp_fset_get_priv_fset)(GTTPFSet *self);
	void (*gttp_fset_set_priv_fset)(GTTPFSet *self, GTTPFSetPrivate *value);


// Class static variables
   	gint instance_count;
    gdouble field_dbl;
    gpointer field_ptr;
};


//Very specific type registration function, to register this fundamental type
// with different combination of flags.
GType register_gttp_fset_type(gboolean has_init);
GType test_register_gttp_fset_type( const gchar* type_name,
									GTypeFundamentalFlags fundamental_flags,
									GTypeFlags type_flags,
									const gpointer class_data,
									gboolean has_init);

void gttp_fset_add(GTTPFSet* self, gpointer element);
void gttp_fset_remove(GTTPFSet* self, gpointer element);
gint gttp_fset_size(GTTPFSet* self);
int gttp_fset_get_instance_id(GTTPFSet* self);
int gttp_fset_get_instance_count();
extern GTTPFSet_CT gttp_fset_ct;

void gttp_fset_set_priv_fset(GTTPFSet *self, GTTPFSetPrivate *svalue);
GTTPFSetPrivate * gttp_fset_get_priv_fset(GTTPFSet *self);

#endif /*GTTPFSET_H_*/
