#ifndef GTTPPOINTLIST_H_
#define GTTPPOINTLIST_H_

#include "gttp-ilist.h"
#include "gttp-pointset.h"
#include "gttp-common.h"
/*
 * Proposed as a descendant of the GTTPPointSet class,
 * implementing GTTPIList interface.
 *
 */


extern GType gttp_type_pointlist;

#define GTTP_TYPE_POINTLIST       (register_gttp_pointlist_type(TRUE))
#define GTTP_TYPE_POINTLIST_NO_INIT       (register_gttp_pointlist_type(FALSE))
#define GTTP_TYPE_POINTLIST_NAME       "GTTPPointList"
#define GTTP_POINTLIST_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_POINTLIST, GTTPPointListClass))
#define GTTP_IS_POINTLIST_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_POINTLIST))

#define GTTP_POINTLIST(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_POINTLIST,  GTTPPointList))
#define GTTP_IS_POINTLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_POINTLIST))
#define GTTP_POINTLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_POINTLIST, GTTPPointListClass))


typedef struct _GTTPPointList GTTPPointList;
typedef struct _GTTPPointListClass GTTPPointListClass;
typedef struct _GTTPPointListPrivate GTTPPointListPrivate;

#define GTTP_POINTLIST_GET_POINTLIST_PRIVATE(o) \
 (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTTP_TYPE_POINTLIST, GTTPPointListPrivate))

#define GTTP_POINTLIST_GET_POINTSET_PRIVATE(o) \
 (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTTP_TYPE_POINTSET, GTTPPointListPrivate))

#define GTTP_POINTLIST_GET_FSET_PRIVATE(o) \
 (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTTP_TYPE_FSET, GTTPPointListPrivate))

struct _GTTPPointListPrivate {
	int member;
};

struct _GTTPPointList{
    GTTPPointSet parent_object;
	int instance_id;
	int parnet_init_order;
};

struct _GTTPPointListClass{
    GTTPPointSetClass parent_class;
    int (*get_instance_count)();
	int (*get_instance_id)(GTTPPointList *self);
	int (*get_init_order)(GTTPPointList *self);
	GTTPPointListPrivate* (*gttp_pointlist_get_priv_pointlist)(GTTPPointList *self);
	GTTPPointListPrivate* (*gttp_pointlist_get_priv_pointset)(GTTPPointList *self);
	GTTPPointListPrivate* (*gttp_pointlist_get_priv_fset)(GTTPPointList *self);
	void (*gttp_pointlist_set_priv_pointlist)(GTTPPointList *self, GTTPPointListPrivate *value);
	void (*gttp_pointlist_set_priv_pointset)(GTTPPointList *self, GTTPPointListPrivate *value);
	void (*gttp_pointlist_set_priv_fset)(GTTPPointList *self, GTTPPointListPrivate *value);
	int instance_count;
};


GType register_gttp_pointlist_type();
GType test_register_gttp_pointlist_type(GType parent_type,
										GType interface_type,
										const gchar* type_name,
										GTypeFlags type_flags,
										const gpointer class_data,
										const gpointer interface_data,
										gboolean has_init);

gpointer gttp_pointlist_get(GTTPPointList* self, gint index);
int gttp_pointlist_get_instance_count();
int gttp_pointlist_get_instance_id(GTTPPointList *self);
int gttp_pointlist_get_init_order(GTTPPointList *self);
void gttp_pointlist_set_priv_pointlist(GTTPPointList *self, GTTPPointListPrivate *svalue);
GTTPPointListPrivate * gttp_pointlist_get_priv_pointlist(GTTPPointList *self);


//Debugging and verification functions
gpointer get_pointlist_ilist_info();
extern GTTPFSet_CT gttp_pointlist_ct;
#endif /*GTTPPOINTLIST_H_*/

