#ifndef GTTPPOINTSET_H_
#define GTTPPOINTSET_H_


#include "gttp-fset.h"
#include "gttp-common.h"

typedef struct _GTTPPoint{
    int x;
    int y;
} GTTPPoint;

/*
 * Proposed as direct descendant of the set class.
 *
 * Operates with points, having integer coordinates.
 *
 */

#define GTTP_TYPE_POINTSET       	(register_gttp_pointset_type(TRUE))
#define GTTP_TYPE_POINTSET_NO_INIT  (register_gttp_pointset_type(FALSE))
#define GTTP_TYPE_POINTSET_NAME   "GTTPPointSet"

#define GTTP_POINTSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_POINTSET, GTTPPointSetClass))
#define GTTP_IS_POINTSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_POINTSET))

#define GTTP_POINTSET(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_POINTSET,  GTTPPointSet))
#define GTTP_IS_POINTSET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_POINTSET))
#define GTTP_POINTSET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_POINTSET, GTTPPointSetClass))


typedef struct _GTTPPointSet GTTPPointSet;
typedef struct _GTTPPointSetClass GTTPPointSetClass;
typedef struct _GTTPPointSetPrivate GTTPPointSetPrivate;

#define GTTP_POINTSET_GET_POINTSET_PRIVATE(o) \
 (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTTP_TYPE_POINTSET, GTTPPointSetPrivate))

#define GTTP_POINTSET_GET_FSET_PRIVATE(o) \
 (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTTP_TYPE_FSET, GTTPPointSetPrivate))

struct _GTTPPointSetPrivate {
	int member;
};

struct _GTTPPointSet{
    GTTPFSet parent_object;
	int instance_id;
	int parnet_init_order;
};

struct _GTTPPointSetClass{
    GTTPFSetClass parent_class;

    gdouble (*distance)(GTTPPointSet* self, GTTPPointSet* other_pointset);
    void (*translate)(GTTPPointSet* self, int x, int y);

    int (*get_instance_count)();
	int (*get_instance_id)(GTTPPointSet *self);
	int (*get_init_order)(GTTPPointSet *self);
	GTTPPointSetPrivate* (*gttp_pointset_get_priv_pointset)(GTTPPointSet *self);
	GTTPPointSetPrivate* (*gttp_pointset_get_priv_fset)(GTTPPointSet *self);
	void (*gttp_pointset_set_priv_pointset)(GTTPPointSet *self, GTTPPointSetPrivate *svalue);
	void (*gttp_pointset_set_priv_fset)(GTTPPointSet *self, GTTPPointSetPrivate *svalue);

    int instance_count;

    gchar field_char;
    glong field_long;
    gint field_int;

};




GType register_gttp_pointset_type();
GType test_register_gttp_pointset_type( GType parent_type,
										const gchar* type_name,
										GTypeFlags type_flags,
										const gpointer class_data,
										gboolean has_init);


//Class methods

void gttp_pointset_set_priv_pointset(GTTPPointSet *self, GTTPPointSetPrivate *svalue);
GTTPPointSetPrivate * gttp_pointset_get_priv_pointset(GTTPPointSet *self);
gdouble gttp_pointset_distance(GTTPPointSet* self, GTTPPointSet* other_pointset);
void gttp_pointset_translate(GTTPPointSet* self, int x, int y);
int gttp_pointset_get_instance_count();
int gttp_pointset_get_instance_id(GTTPPointSet *self);
gboolean gttp_pointset_get_init_order(GTTPPointSet *self);

#endif /*GTTPPOINTSET_H_*/

