#ifndef GTTPSORTEDPOINTLIST_H_
#define GTTPSORTEDPOINTLIST_H_

#include "gttp-pointlist.h"

/*
 * Proposed as a descendant of the GTTPPointList class.
 * Represents a kind of sorted point list, where order
 * is determined by the provided callback function.
 *
 */


typedef gint (*GTTPPointCompare) (GTTPPoint* point1, GTTPPoint* point2);

//*******************************************************************************

#define GTTP_TYPE_SORTEDPOINTLIST       (register_gttp_sortedpointlist_type())

#define GTTP_SORTEDPOINTLIST_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_SORTEDPOINTLIST, GTTPSortedPointListClass))
#define GTTP_IS_SORTEDPOINTLIST_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_SORTEDPOINTLIST))

#define GTTP_SORTEDPOINTLIST(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_SORTEDPOINTLIST,  GTTPSortedPointList))
#define GTTP_IS_SORTEDPOINTLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_SORTEDPOINTLIST))
#define GTTP_SORTEDPOINTLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_SORTEDPOINTLIST, GTTPSortedPointListClass))


typedef struct _GTTPSortedPointList GTTPSortedPointList;
typedef struct _GTTPSortedPointListClass GTTPSortedPointListClass;

struct _GTTPSortedPointList{
    GTTPPointList parent_object;

    GTTPPointCompare cmp_func;
};

struct _GTTPSortedPointListClass{
    GTTPPointListClass parent_class;

    void (*set_cmp_func)(GTTPSortedPointList* self, GTTPPointCompare cmp_func);
};

//Type registration
GType register_gttp_sortedpointlist_type();
GType test_register_gttp_sortedpointlist_type(GType parent_type, const gchar* type_name, GTypeFlags type_flags, const gpointer class_data);




//Class methods
void gttp_sortedpointlist_set_cmp_func(GTTPSortedPointList* self, GTTPPointCompare cmp_func);

#endif /*GTTPSORTEDPOINTLIST_H_*/
