#include "gttp-fmap.h"

#include <t2c.h>
extern int bVerbose;

static void gttp_fmap_base_init(gpointer g_class);
static void gttp_fmap_base_finalize(gpointer g_class);
static void gttp_fmap_class_init(gpointer g_class, gpointer class_data);
//static void gttp_fmap_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_fmap_instance_init(GTypeInstance *instance, gpointer g_class);

static void gttp_fmap_imap_interface_init (gpointer g_iface, gpointer iface_data);
static void gttp_fmap_imap_interface_finalize (gpointer g_iface, gpointer iface_data);

GType gttp_type_fmap_t = 0;

GType register_gttp_fmap_type()
{
    static GType gttp_type_fmap = 0;
    if(gttp_type_fmap == 0)
    {
        if(gttp_type_fmap_t == 0)
        {
            gttp_type_fmap = test_register_gttp_fmap_type("GTTPFMap",
                                                 GTTP_TYPE_IMAP,
                                                 G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE |
                                                 G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE,
                                                 0, NULL, NULL);
        }else{
            gttp_type_fmap = gttp_type_fmap_t;
        }
    }
    return gttp_type_fmap;
}

GTypeInfo fmap_type_info;
GInterfaceInfo imap_ilist_info;

GType test_register_gttp_fmap_type( const gchar* type_name,
                                    GType imap_iface_type,
                                    GTypeFundamentalFlags fundamental_flags,
                                    GTypeFlags type_flags,
                                    const gpointer class_data, const gpointer imap_iface_data)
{

    gboolean is_classed = (fundamental_flags & G_TYPE_FLAG_CLASSED) == G_TYPE_FLAG_CLASSED;
    gboolean is_instantiable = is_classed && (fundamental_flags & G_TYPE_FLAG_INSTANTIATABLE) == G_TYPE_FLAG_INSTANTIATABLE;

    GType next_ftypeid = g_type_fundamental_next();

    GTypeFundamentalInfo fndtype_info = {fundamental_flags};

    guint16 class_size = is_classed ? sizeof(GTTPFMapClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_fmap_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_fmap_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_fmap_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = NULL;
    GInstanceInitFunc instance_init_func = is_instantiable ? gttp_fmap_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPFMap) : 0;

    const gchar* ctype_name = type_name == NULL ? "GTTPFMap" : type_name;


    fmap_type_info.class_size = class_size;
    fmap_type_info.base_init = base_init_func;
    fmap_type_info.base_finalize = base_finalize_func;
    fmap_type_info.class_init = class_init_func;
    fmap_type_info.class_finalize = class_finalize_func;
    fmap_type_info.class_data = fclass_data;
    fmap_type_info.instance_size = instance_size;
    fmap_type_info.n_preallocs = 0;
    fmap_type_info.instance_init = instance_init_func;
    fmap_type_info.value_table = NULL;


    gttp_type_fmap_t = g_type_register_fundamental(
                                next_ftypeid,
                                ctype_name,
                                &fmap_type_info,
                                &fndtype_info,
                                type_flags);

    imap_ilist_info.interface_init = gttp_fmap_imap_interface_init;
    imap_ilist_info.interface_finalize = gttp_fmap_imap_interface_finalize;
    imap_ilist_info.interface_data = imap_iface_data;



    g_type_add_interface_static (gttp_type_fmap_t,
                                 imap_iface_type,
                                 &imap_ilist_info);


    return gttp_type_fmap_t;
}


// Class initialization methods

static void gttp_fmap_base_init(gpointer g_class)
{

//    TRACE("%s called; type name = %s", __func__, g_type_name(G_TYPE_FROM_CLASS(g_class)))

    if(IS_USED_CT(gttpfmap_ct))
    {
        gttpfmap_ct.base_init_call_count++;

        if(gttpfmap_ct.base_init_call_count > gttpfmap_ct.exp_base_init_call_count)
        {
            TRACE("%s: GTypeInfo.base_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttpfmap_ct.base_init_call_count, gttpfmap_ct.exp_base_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttpfmap_ct.base_init_params_valid = FALSE;
            return;
        }

        if(G_TYPE_FROM_CLASS(g_class) != gttp_type_fmap_t)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttpfmap_ct.base_init_params_valid = FALSE;
            return;
        }

        if(!(GTTP_FMAP_CLASS(g_class)->field_long == 0 &&
            GTTP_FMAP_CLASS(g_class)->field_bool == 0 &&
            GTTP_FMAP_CLASS(g_class)->field_ptr == 0))
        {
            TRACE("%s: GTypeInfo.base_init: the fields of class structures were not zero initialized.", __func__)
            gttpfmap_ct.class_struct_zero_filled = FALSE;
        }else{
            gttpfmap_ct.class_struct_zero_filled = TRUE;
        }

        gttpfmap_ct.base_init_params_valid = TRUE;
        gttpfmap_ct.class_init_p_exp_class = g_class;
    }

    if(IS_USED_CT(gttptreemap_ct))
    {
        gttptreemap_ct.parent_base_init_call_count++;

        if(gttptreemap_ct.parent_base_init_call_count > gttptreemap_ct.exp_parent_base_init_call_count)
        {
            TRACE("%s: GTypeInfo.base_init: the class parent callback was called %d times instead of expected %d times.", __func__,
                            gttptreemap_ct.parent_base_init_call_count, gttptreemap_ct.exp_parent_base_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL for the class parent callback.", __func__);
            gttptreemap_ct.base_init_params_valid = FALSE;
            return;
        }

        if(gttptreemap_ct.parent_base_init_call_count == 1)
        {
            if(G_TYPE_FROM_CLASS(g_class) != gttp_type_fmap_t)
            {
                TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class' for the class parent callback, for the first time it should be of type of the parent class itself.", __func__);
            }

        }else{

            if(G_TYPE_FROM_CLASS(g_class) !=
                gttptreemap_ct.parent_base_init_p_exp_class_type[gttptreemap_ct.parent_base_init_call_count - 1])
            {
                TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class' for the class parent callback, on the subsequent calls it should be of type of the descendant.", __func__);
                gttptreemap_ct.base_init_params_valid = FALSE;
                return;
            }
        }
        gttptreemap_ct.parent_base_init_params_valid = TRUE;
    }

}

static void gttp_fmap_base_finalize(gpointer g_class)
{

}


static void gttp_fmap_class_init(gpointer g_class, gpointer class_data)
{

//    TRACE("%s called; type name = %s", __func__, g_type_name(G_TYPE_FROM_CLASS(g_class)))

    if(IS_USED_CT(gttpfmap_ct))
    {
        gttpfmap_ct.class_init_call_count++;

        if(gttpfmap_ct.base_init_call_count == 0)
        {
            TRACE("%s: GTypeInfo.class_init: class_init() callback is called earlier than base_init().",  __func__)
            gttpfmap_ct.init_call_order_valid = FALSE;
            return;
        }

        gttpfmap_ct.init_call_order_valid = TRUE;

        if(gttpfmap_ct.class_init_call_count > gttpfmap_ct.exp_class_init_call_count)
        {
            TRACE("%s: GTypeInfo.class_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttpfmap_ct.class_init_call_count, gttpfmap_ct.exp_class_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttpfmap_ct.class_init_params_valid = FALSE;
            return;
        }

        if(gttpfmap_ct.class_init_p_exp_class != g_class)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttpfmap_ct.class_init_params_valid = FALSE;
            return;
        }


        if(class_data != gttpfmap_ct.class_init_p_exp_class_data)
        {
            TRACE("%s: GTypeInfo.class_init: the 'gpointer class_data' parameter passed in does not have the expected value.", __func__)
            gttpfmap_ct.class_init_params_valid = FALSE;
            return;
        }


        gttpfmap_ct.class_init_params_valid = TRUE;
    }

    if(IS_USED_CT(gttptreemap_ct))
    {
        gttptreemap_ct.parent_class_init_call_count++;
    }

    GTTP_FMAP_CLASS(g_class)->field_ptr = (gpointer)FMAP_FIELD_PTR_INIT_VALUE;
    GTTP_FMAP_CLASS(g_class)->field_bool = FMAP_FIELD_BOOL_INIT_VALUE;
    GTTP_FMAP_CLASS(g_class)->field_long = FMAP_FIELD_LONG_INIT_VALUE;

}


//static void gttp_fmap_class_finalize(gpointer g_class, gpointer class_data)
//{
//
//}

//GInterfaceInfo methods

static void gttp_fmap_imap_interface_init (gpointer g_iface, gpointer iface_data)
{
    if(IS_USED_CT(gttpfmap_ct))
    {
        gttpfmap_ct.class_iface_init_call_count++;

//        TRACE("g_iface=%p;name=%s;imap_g_info=%p;fmap_g_class=%p", g_iface, g_type_name(G_TYPE_FROM_CLASS(g_iface)), gttpimap_ct.class_init_p_exp_class, gttpfmap_ct.iface_base_init_call_p_g_class);


        if(IS_USED_CT(gttpimap_ct))
        {
            if(gttpimap_ct.base_init_call_count < gttpimap_ct.exp_base_init_call_count)
            {
                TRACE("%s: GInterfaceInfo.interface_init: the registered callback was called before calling all the 'GTypeInfo.base_init' initialization functions of the implemented interface.", __func__);
                gttpfmap_ct.class_iface_init_call_order_valid = FALSE;
                return;
            }


            //This will be verified only if interface checklists are used and
            //thus 'iface_base_init_call_p_g_class' field is properly initialized.
            if(g_iface != gttpfmap_ct.iface_base_init_call_p_g_class )
            {
                TRACE("%s: GInterfaceInfo.interface_init: invalid vtable passed in as a parameter 'gpointer g_iface'.", __func__);
                gttpfmap_ct.class_iface_init_params_valid = FALSE;
                return;
            }

        }

        if(gttpfmap_ct.class_init_call_count == 0)
        {
            TRACE("%s: GInterfaceInfo.interface_init: the registered callback was called before calling all the 'GTypeInfo.class_init' initialization functions of the class.", __func__);
            gttpfmap_ct.class_iface_init_call_order_valid = FALSE;
            return;
        }

        gttpfmap_ct.class_iface_init_call_order_valid = TRUE;


        if(g_iface == NULL )
        {
            TRACE("%s: GInterfaceInfo.interface_init: NULL passed in for the parameter 'gpointer g_iface'.", __func__);
            gttpfmap_ct.class_iface_init_params_valid = FALSE;
            return;
        }

        if(G_TYPE_FROM_CLASS(g_iface) != GTTP_TYPE_IMAP)
        {
            TRACE("%s: GInterfaceInfo.interface_init: the vtable passed in for the parameter 'gpointer g_iface' is of invalid type.", __func__);
            gttpfmap_ct.class_iface_init_params_valid = FALSE;
            return;
        }


        if(iface_data != gttpfmap_ct.class_iface_init_p_exp_iface_data)
        {
            TRACE("%s: GInterfaceInfo.interface_init: invalid value passed in for the parameter 'gpointer iface_data'.", __func__);
            gttpfmap_ct.class_iface_init_params_valid = FALSE;
            return;
        }

        gttpfmap_ct.class_iface_init_params_valid = TRUE;


        if(gttpfmap_ct.icheck_handler_1_call_count > 0 ||
            gttpfmap_ct.icheck_handler_2_call_count > 0)
        {
            TRACE("%s: g_type_add_interface_check: interface check callback was called before 'GInterfaceInfo.interface_init' callback.", __func__);
            gttpfmap_ct.icheck_call_order_valid = FALSE;
            return;
        }

        gttpfmap_ct.icheck_call_order_valid = TRUE;
        gttpfmap_ct.exp_g_iface = g_iface;

    }


}

static void gttp_fmap_imap_interface_finalize (gpointer g_iface, gpointer iface_data)
{

}


//Instance initialization method

static void gttp_fmap_instance_init(GTypeInstance *instance, gpointer g_class)
{

}
