
#include "gttp-fset.h"

#include <t2c.h>
extern int bVerbose;
static void gttp_fset_base_init(gpointer g_class);
static void gttp_fset_base_finalize(gpointer g_class);
static void gttp_fset_class_init(gpointer g_class, gpointer class_data);
//static void gttp_fset_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_fset_instance_init(GTypeInstance *instance, gpointer g_class);


static void __gttp_fset_add(GTTPFSet* self, gpointer element);
static void __gttp_fset_remove(GTTPFSet* self, gpointer element);
static gint __gttp_fset_size(GTTPFSet* self);
static int __get_instance_count();
static int __get_instance_id(GTTPFSet* self);
static GTTPFSetPrivate * __gttp_fset_get_priv_fset (GTTPFSet *pset);
static void __gttp_fset_set_priv_fset (GTTPFSet *pset, GTTPFSetPrivate *svalue );


GType gttp_type_fset_t = 0;


GType register_gttp_fset_type(gboolean has_init)
{
	static int gttp_type_fset = 0;
    if(gttp_type_fset == 0)
    {
        if(gttp_type_fset_t == 0){
            gttp_type_fset = test_register_gttp_fset_type(GTTP_TYPE_FSET_NAME,
        										 G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE |
        										 G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE,
        										 0, NULL, has_init);
        }else{
            gttp_type_fset = gttp_type_fset_t;
        }
    }
    return gttp_type_fset;
}



GTypeInfo fset_type_info;

GType test_register_gttp_fset_type( const gchar* type_name,
									GTypeFundamentalFlags fundamental_flags,
									GTypeFlags type_flags,
									const gpointer class_data, gboolean has_init)
{

    gboolean is_classed = (fundamental_flags & G_TYPE_FLAG_CLASSED) == G_TYPE_FLAG_CLASSED;
    gboolean is_instantiable = is_classed && (fundamental_flags & G_TYPE_FLAG_INSTANTIATABLE) == G_TYPE_FLAG_INSTANTIATABLE;

    GType next_ftypeid = g_type_fundamental_next();

    GTypeFundamentalInfo fndtype_info = {fundamental_flags};

    guint16 class_size = is_classed ? sizeof(GTTPFSetClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_fset_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_fset_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_fset_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = NULL;
    GInstanceInitFunc instance_init_func = (is_instantiable && has_init) ? gttp_fset_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPFSet) : 0;

    fset_type_info.class_size = class_size;
    fset_type_info.base_init = base_init_func;
    fset_type_info.base_finalize = base_finalize_func;
    fset_type_info.class_init = class_init_func;
    fset_type_info.class_finalize = class_finalize_func;
    fset_type_info.class_data = fclass_data;
    fset_type_info.instance_size = instance_size;
    fset_type_info.n_preallocs = 0;
    fset_type_info.instance_init = instance_init_func;
    fset_type_info.value_table = NULL;


    const gchar* ctype_name = type_name == NULL ? GTTP_TYPE_FSET_NAME : type_name;


    gttp_type_fset_t = g_type_register_fundamental(
                                next_ftypeid,
                                ctype_name,
                                &fset_type_info,
                                &fndtype_info,
                                type_flags);

    return gttp_type_fset_t;
}


// Class initialization methods

static void gttp_fset_base_init(gpointer g_class)
{
    if(IS_USED_CT(gttpfset_ct))
    {
        gttpfset_ct.base_init_call_count++;

        if(gttpfset_ct.base_init_call_count > gttpfset_ct.exp_base_init_call_count)
        {
            TRACE("%s: GTypeInfo.base_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttpfset_ct.base_init_call_count, gttpfset_ct.exp_base_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttpfset_ct.base_init_params_valid = FALSE;
            return;
        }

        if(G_TYPE_FROM_CLASS(g_class) != gttp_type_fset_t)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttpfset_ct.base_init_params_valid = FALSE;
            return;
        }

        if(!(GTTP_FSET_CLASS(g_class)->instance_count == 0 &&
            GTTP_FSET_CLASS(g_class)->field_dbl == 0.0 &&
            GTTP_FSET_CLASS(g_class)->field_ptr == 0))
        {
            TRACE("%s: GTypeInfo.base_init: the fields of class structures were not zero initialized.", __func__)
            gttpfset_ct.class_struct_zero_filled = FALSE;
        }else{
            gttpfset_ct.class_struct_zero_filled = TRUE;
        }

        gttpfset_ct.base_init_params_valid = TRUE;
        gttpfset_ct.class_init_p_exp_class = g_class;
    }

     if(IS_USED_CT(gttppointset_ct))
    {
        gttppointset_ct.parent_base_init_call_count++;

        if(gttppointset_ct.parent_base_init_call_count > gttppointset_ct.exp_parent_base_init_call_count)
        {
            TRACE("%s: GTypeInfo.base_init: the class parent callback was called %d times instead of expected %d times.", __func__,
                            gttppointset_ct.parent_base_init_call_count, gttppointset_ct.exp_parent_base_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL for the class parent callback.", __func__);
            gttppointset_ct.base_init_params_valid = FALSE;
            return;
        }

        if(gttppointset_ct.parent_base_init_call_count == 1)
        {
            if(G_TYPE_FROM_CLASS(g_class) != gttp_type_fset_t)
            {
                TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class' for the class parent callback, for the first time it should be of type of the parent class itself.", __func__);
            }

        }else{

            if(G_TYPE_FROM_CLASS(g_class) !=
                gttppointset_ct.parent_base_init_p_exp_class_type[gttppointset_ct.parent_base_init_call_count - 1])
            {
                TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class' for the class parent callback, on the subsequent calls it should be of type of the descendant.", __func__);
                gttppointset_ct.base_init_params_valid = FALSE;
                return;
            }
        }
        gttppointset_ct.parent_base_init_params_valid = TRUE;
    }
}

static void gttp_fset_base_finalize(gpointer g_class)
{

}


static void gttp_fset_class_init(gpointer g_class, gpointer class_data)
{
    if(IS_USED_CT(gttpfset_ct))
    {
        gttpfset_ct.class_init_call_count++;

        if(gttpfset_ct.base_init_call_count == 0)
        {
            TRACE("%s: GTypeInfo.class_init: class_init() callback is called earlier than base_init().",  __func__)
            gttpfset_ct.init_call_order_valid = FALSE;
            return;
        }

        gttpfset_ct.init_call_order_valid = TRUE;

        if(gttpfset_ct.class_init_call_count > gttpfset_ct.exp_class_init_call_count)
        {
            TRACE("%s: GTypeInfo.class_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttpfset_ct.class_init_call_count, gttpfset_ct.exp_class_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttpfset_ct.class_init_params_valid = FALSE;
            return;
        }

        if(gttpfset_ct.class_init_p_exp_class != g_class)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttpfset_ct.class_init_params_valid = FALSE;
            return;
        }


        if(class_data != gttpfset_ct.class_init_p_exp_class_data)
        {
            TRACE("%s: GTypeInfo.class_init: the 'gpointer class_data' parameter passed in does not have the expected value.", __func__)
            gttpfset_ct.class_init_params_valid = FALSE;
            return;
        }


        gttpfset_ct.class_init_params_valid = TRUE;
    }

	if(IS_USED_CT(gttppointset_ct))
    {
        gttppointset_ct.parent_class_init_call_count++;
    }

	if(!GTTP_IS_FSET_CLASS(g_class)) {
		TRACE("%s WARNING !!! The class init is called with wrong type", __func__);
		return;
	}

    GTTP_FSET_CLASS(g_class)->add = __gttp_fset_add;
    GTTP_FSET_CLASS(g_class)->remove = __gttp_fset_remove;
    GTTP_FSET_CLASS(g_class)->size = __gttp_fset_size;
    GTTP_FSET_CLASS(g_class)->get_instance_count = __get_instance_count;
    GTTP_FSET_CLASS(g_class)->get_instance_id = __get_instance_id;
	GTTP_FSET_CLASS(g_class)->gttp_fset_get_priv_fset = __gttp_fset_get_priv_fset;
	GTTP_FSET_CLASS(g_class)->gttp_fset_set_priv_fset = __gttp_fset_set_priv_fset;


    GTTP_FSET_CLASS(g_class)->instance_count = FSET_FIELD_ICOUNT_INIT_VALUE;

    GTTP_FSET_CLASS(g_class)->field_ptr = (gpointer)FSET_FIELD_PTR_INIT_VALUE;
    GTTP_FSET_CLASS(g_class)->field_dbl = FSET_FIELD_DBL_INIT_VALUE;

    if(G_TYPE_IS_INSTANTIATABLE(G_TYPE_FROM_CLASS(g_class)))
        g_type_class_add_private (g_class, sizeof (GTTPFSetPrivate));

}


//static void gttp_fset_class_finalize(gpointer g_class, gpointer class_data)
//{
//	;
//}


//Instance initialization method

static void gttp_fset_instance_init(GTypeInstance *instance, gpointer g_class)
{
    GTTPFSet *self = NULL;
	++gttpfset01_ct.instance_count;
	if(instance == NULL)
	{
		TRACE("%s The instance is NULL", __func__);
		gttpfset01_ct.instance_not_null = FALSE;
		return;
	}
	gttpfset01_ct.instance_not_null = TRUE;

	if(g_class == NULL)
	{
		TRACE("%s The g_class is NULL", __func__);
		gttpfset01_ct.class_not_null = FALSE;
		return;
	}
	gttpfset01_ct.class_not_null = TRUE;

	if(!GTTP_IS_FSET_CLASS(g_class))
	{
		TRACE("%s The local class type is not derived from FSET", __func__);
		gttpfset01_ct.local_class_type_is_valid = FALSE;
		return;
	}
	gttpfset01_ct.local_class_type_is_valid = TRUE;

	if(!GTTP_IS_FSET(instance))
	{
		TRACE("%s The local instance type is not derived from FSET", __func__);
		gttpfset01_ct.local_instance_type_is_valid = FALSE;
		return;
	}
	gttpfset01_ct.local_instance_type_is_valid = TRUE;

	if(!G_TYPE_CHECK_CLASS_TYPE(g_class, gttpfset01_ct.expected_class_type))
	{
		TRACE("%s The current type is not expected", __func__);
		gttpfset01_ct.expected_class_type_is_valid = FALSE;
		return;
	}
	gttpfset01_ct.expected_class_type_is_valid = TRUE;

	if(!G_TYPE_FROM_INSTANCE(instance) == gttpfset01_ct.expected_class_type)
	{
		TRACE("%s The current instance type is not expected", __func__);
		gttpfset01_ct.expected_instance_type_is_valid = FALSE;
		return;
	}
	gttpfset01_ct.expected_instance_type_is_valid = TRUE;
	self = GTTP_FSET(instance);
	if( self->instance_id != 0 ) {
		TRACE("%s The instance id is not 0", __func__);
		gttpfset01_ct.class_struct_zero_filled = FALSE;
		return;

	}
	gttpfset01_ct.class_struct_zero_filled = TRUE;
	if(GTTP_FSET_GET_FSET_PRIVATE(self) == NULL) {
		gttpfset01_ct.private_init_is_done = FALSE;
		return;
	}
	gttpfset01_ct.private_init_is_done = TRUE;

    self->instance_id = gttpfset01_ct.instance_count;
}


//Public wrappers of the class methods
void gttp_fset_add(GTTPFSet* self, gpointer element)
{
    GTTP_FSET_GET_CLASS(self)->add(self, element);
}

void gttp_fset_remove(GTTPFSet* self, gpointer element)
{
    GTTP_FSET_GET_CLASS(self)->remove(self, element);
}

gint gttp_fset_size(GTTPFSet* self)
{
    return GTTP_FSET_GET_CLASS(self)->size(self);
}

int gttp_fset_get_instance_id(GTTPFSet* self) {
    return GTTP_FSET_GET_CLASS(self)->get_instance_id(self);
}

int gttp_fset_get_instance_count() {
    GTTPFSetClass *g_class = GTTP_FSET_CLASS(g_type_class_ref(GTTP_TYPE_FSET));
    gint ic = g_class->get_instance_count();
    g_type_class_unref(g_class);
    return ic;
}

GTTPFSetPrivate * gttp_fset_get_priv_fset(GTTPFSet *self)
{
	if(self == NULL)
	{
		gttpfset01_ct.instance_not_null = FALSE;
		return NULL;
	}
	gttpfset01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_FSET(self))
	{
		gttpfset01_ct.local_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttpfset01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttpfset01_ct.expected_class_type)
	{
		gttpfset01_ct.expected_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttpfset01_ct.expected_instance_type_is_valid = TRUE;

	return GTTP_FSET_GET_CLASS(self)->gttp_fset_get_priv_fset(self);
}

void gttp_fset_set_priv_fset(GTTPFSet *self, GTTPFSetPrivate *svalue)
{
	if(self == NULL)
	{
		gttpfset01_ct.instance_not_null = FALSE;
		return;
	}
	gttpfset01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_FSET(self))
	{
		gttpfset01_ct.local_instance_type_is_valid = FALSE;
		return ;
	}
	gttpfset01_ct.local_instance_type_is_valid = TRUE;

/*	if(G_TYPE_FROM_INSTANCE(self) != gttpfset01_ct.expected_class_type)
	{
		gttpfset01_ct.expected_instance_type_is_valid = FALSE;
		return ;
	}*/
	gttpfset01_ct.expected_instance_type_is_valid = TRUE;

	GTTP_FSET_GET_CLASS(self)->gttp_fset_set_priv_fset(self, svalue);
}



//Implementation of class methods


static void __gttp_fset_add(GTTPFSet* self, gpointer element)
{
	if(self == NULL)
	{
		gttpfset01_ct.instance_not_null = FALSE;
		return;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttpfset01_ct.local_instance_type_is_valid = FALSE;
		return;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttpfset01_ct.expected_class_type)
	{
		gttpfset01_ct.expected_instance_type_is_valid = FALSE;
		return;
	}

	gttpfset01_ct.instance_not_null = TRUE;
	gttpfset01_ct.local_instance_type_is_valid = TRUE;
	gttpfset01_ct.expected_instance_type_is_valid = TRUE;
    self->element_count++;
}

static void __gttp_fset_remove(GTTPFSet* self, gpointer element)
{
	if(self == NULL)
	{
		gttpfset01_ct.instance_not_null = FALSE;
		return;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttpfset01_ct.local_instance_type_is_valid = FALSE;
		return;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttpfset01_ct.expected_class_type)
	{
		gttpfset01_ct.expected_instance_type_is_valid = FALSE;
		return;
	}

	gttpfset01_ct.instance_not_null = TRUE;
	gttpfset01_ct.local_instance_type_is_valid = TRUE;
	gttpfset01_ct.expected_instance_type_is_valid = TRUE;
    self->element_count--;
}

static gint __gttp_fset_size(GTTPFSet* self)
{
	if(self == NULL)
	{
		gttpfset01_ct.instance_not_null = FALSE;
		return -1;
	}

//Carefully initialize the expected class type otherwise error guaranteed.
	if(!GTTP_IS_FSET(self))
	{
		gttpfset01_ct.local_instance_type_is_valid = FALSE;
		return -1;
	}


	if(!G_TYPE_FROM_INSTANCE(self) == gttpfset01_ct.expected_class_type)
	{
		gttpfset01_ct.expected_instance_type_is_valid = FALSE;
		return -11;
	}

	gttpfset01_ct.instance_not_null = TRUE;
	gttpfset01_ct.local_instance_type_is_valid = TRUE;
	gttpfset01_ct.expected_instance_type_is_valid = TRUE;
    return self->element_count;
}

static int __get_instance_count() {
    return gttpfset01_ct.instance_count;
}

static int __get_instance_id(GTTPFSet* self) {
	if(self == NULL)
	{
		gttpfset01_ct.instance_not_null = FALSE;
		return -1;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttpfset01_ct.local_instance_type_is_valid = FALSE;
		return -1;
	}

	if(!(G_TYPE_FROM_INSTANCE(self) == gttpfset01_ct.expected_class_type))
	{
		gttpfset01_ct.expected_instance_type_is_valid = FALSE;
		return -1;
	}

	gttpfset01_ct.instance_not_null = TRUE;
	gttpfset01_ct.local_instance_type_is_valid = TRUE;
	gttpfset01_ct.expected_instance_type_is_valid = TRUE;
    return self->instance_id;
}

static GTTPFSetPrivate * __gttp_fset_get_priv_fset (GTTPFSet *pset)
{
 	GTTPFSetPrivate *priv = GTTP_FSET_GET_FSET_PRIVATE (pset);
 	return priv;
}

static void __gttp_fset_set_priv_fset (GTTPFSet *pset, GTTPFSetPrivate *svalue )
{
 	GTTPFSetPrivate *priv = GTTP_FSET_GET_FSET_PRIVATE (pset);
 	memcpy(priv, svalue, sizeof(GTTPFSetPrivate));
}
