
#include "gttp-pointset.h"
#include "gttp-common.h"
#include <t2c.h>
extern int bVerbose;
static void gttp_pointset_base_init(gpointer g_class);
static void gttp_pointset_base_finalize(gpointer g_class);
static void gttp_pointset_class_init(gpointer g_class, gpointer class_data);
//void gttp_pointset_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_pointset_instance_init(GTypeInstance *instance, gpointer g_class);

static gdouble __gttp_pointset_distance(GTTPPointSet* self, GTTPPointSet* other_pointset);
static void __gttp_pointset_translate(GTTPPointSet* self, int x, int y);
static int __get_instance_count();
static int __get_instance_id(GTTPPointSet *self);
static int __get_init_order(GTTPPointSet *self);
static GTTPPointSetPrivate * __gttp_pointset_get_priv_pointset (GTTPPointSet *pset);
static GTTPPointSetPrivate * __gttp_pointset_get_priv_fset (GTTPPointSet *pset);
static void __gttp_pointset_set_priv_fset (GTTPPointSet *pset, GTTPPointSetPrivate *svalue );
static void __gttp_pointset_set_priv_pointset (GTTPPointSet *pset, GTTPPointSetPrivate *svalue );




GType gttp_type_pointset_t;


GType register_gttp_pointset_type(gboolean has_init)
{
    static GType gttp_type_pointset = 0;
    if(gttp_type_pointset == 0)
    {
        if(gttp_type_pointset_t == 0)
        {
            gttp_type_pointset = test_register_gttp_pointset_type(GTTP_TYPE_FSET,
        													  GTTP_TYPE_POINTSET_NAME,
        													  0, NULL, has_init);
        }else{
            gttp_type_pointset = gttp_type_pointset_t;
        }
    }

    return gttp_type_pointset;
}

GTypeInfo pointset_type_info;

GType test_register_gttp_pointset_type(	GType parent_type,
										const gchar* type_name,
										GTypeFlags type_flags,
										const gpointer class_data,
										gboolean has_init)
{

    gboolean is_classed = G_TYPE_IS_CLASSED(parent_type);
    gboolean is_instantiable = is_classed && G_TYPE_IS_INSTANTIATABLE(parent_type);

    guint16 class_size = is_classed ? sizeof(GTTPPointSetClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_pointset_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_pointset_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_pointset_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = NULL;
    GInstanceInitFunc instance_init_func = (is_instantiable && has_init) ? gttp_pointset_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPPointSet) : 0;


    pointset_type_info.class_size = class_size;
    pointset_type_info.base_init = base_init_func;
    pointset_type_info.base_finalize = base_finalize_func;
    pointset_type_info.class_init = class_init_func;
    pointset_type_info.class_finalize = class_finalize_func;
    pointset_type_info.class_data = fclass_data;
    pointset_type_info.instance_size = instance_size;
    pointset_type_info.n_preallocs = 0;
    pointset_type_info.instance_init = instance_init_func;
    pointset_type_info.value_table = NULL;

    const gchar* ctype_name = type_name == NULL ? "GTTPPointSet" : type_name;

    gttp_type_pointset_t = g_type_register_static (parent_type,
                            ctype_name,
                            &pointset_type_info,
                            type_flags);



    return gttp_type_pointset_t;
}

//GTypeInfo methods

static void gttp_pointset_base_init(gpointer g_class)
{

    if(IS_USED_CT(gttppointset_ct))
    {
        gttppointset_ct.base_init_call_count++;

        if(gttppointset_ct.base_init_call_count > gttppointset_ct.exp_base_init_call_count)
        {
            TRACE("%s: GTypeInfo.base_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttppointset_ct.base_init_call_count, gttppointset_ct.exp_base_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttppointset_ct.base_init_params_valid = FALSE;
            return;
        }

        if(G_TYPE_FROM_CLASS(g_class) != gttp_type_pointset_t)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttppointset_ct.base_init_params_valid = FALSE;
            return;
        }


        if(!(GTTP_FSET_CLASS(g_class)->instance_count == FSET_FIELD_ICOUNT_INIT_VALUE &&
            GTTP_FSET_CLASS(g_class)->field_dbl == FSET_FIELD_DBL_INIT_VALUE &&
            GTTP_FSET_CLASS(g_class)->field_ptr == (gpointer)FSET_FIELD_PTR_INIT_VALUE))
        {
            TRACE("%s: GTypeInfo.base_init: the values of the fields of class structure were not copied from parent class.", __func__)
            gttppointset_ct.class_struct_common_copied = FALSE;
            return;
        }

        gttppointset_ct.class_struct_common_copied = TRUE;

        if(!(GTTP_POINTSET_CLASS(g_class)->instance_count == 0 &&
            GTTP_POINTSET_CLASS(g_class)->field_long == 0 &&
            GTTP_POINTSET_CLASS(g_class)->field_int == 0 &&
            GTTP_POINTSET_CLASS(g_class)->field_char == 0))
        {
            TRACE("%s: GTypeInfo.base_init: the remaining fields were not initialized.", __func__)
            gttppointset_ct.class_struct_zero_filled = FALSE;
            return;
        }

        gttppointset_ct.class_struct_zero_filled = TRUE;


        gttppointset_ct.base_init_params_valid = TRUE;
        gttppointset_ct.class_init_p_exp_class = g_class;
    }

}

static void gttp_pointset_base_finalize(gpointer g_class)
{

}

static void gttp_pointset_class_init(gpointer g_class, gpointer class_data)
{

    if(IS_USED_CT(gttppointset_ct))
    {
        gttppointset_ct.class_init_call_count++;

        if(gttppointset_ct.base_init_call_count == 0)
        {
            TRACE("%s: GTypeInfo.class_init: class_init() callback is called earlier than base_init().",  __func__)
            gttppointset_ct.init_call_order_valid = FALSE;
            return;
        }

        gttppointset_ct.init_call_order_valid = TRUE;

        if(gttppointset_ct.class_init_call_count > gttppointset_ct.exp_class_init_call_count)
        {
            TRACE("%s: GTypeInfo.class_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttppointset_ct.class_init_call_count, gttppointset_ct.exp_class_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttppointset_ct.class_init_params_valid = FALSE;
            return;
        }

        if(gttppointset_ct.class_init_p_exp_class != g_class)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttppointset_ct.class_init_params_valid = FALSE;
            return;
        }


        if(class_data != gttppointset_ct.class_init_p_exp_class_data)
        {
            TRACE("%s: GTypeInfo.class_init: the 'gpointer class_data' parameter passed in does not have the expected value.", __func__)
            gttppointset_ct.class_init_params_valid = FALSE;
            return;
        }


        gttppointset_ct.class_init_params_valid = TRUE;
    }


	if(!GTTP_IS_POINTSET_CLASS(g_class)) {
		TRACE("%s WARNING !!! The class init is called with wrong type", __func__);
		return;
	}

	if(!GTTP_IS_FSET_CLASS(g_class))
	{
		gttppointset01_ct.local_class_type_is_valid = FALSE;
		return;
	}

/*	if(!G_TYPE_CHECK_CLASS_TYPE(g_class, gttppointset01_ct.expected_class_type))
	{
		gttppointset01_ct.expected_class_type_is_valid = FALSE;
		return;
	}*/

	gttppointset01_ct.class_not_null = TRUE;
	gttppointset01_ct.local_class_type_is_valid = TRUE;
	gttppointset01_ct.expected_class_type_is_valid = TRUE;


    GTTP_POINTSET_CLASS(g_class)->distance = __gttp_pointset_distance;
    GTTP_POINTSET_CLASS(g_class)->translate = __gttp_pointset_translate;
    GTTP_POINTSET_CLASS(g_class)->get_instance_count = __get_instance_count;
    GTTP_POINTSET_CLASS(g_class)->get_instance_id = __get_instance_id;
	GTTP_POINTSET_CLASS(g_class)->get_init_order = __get_init_order;

	GTTP_POINTSET_CLASS(g_class)->gttp_pointset_set_priv_pointset = __gttp_pointset_set_priv_pointset;
	GTTP_POINTSET_CLASS(g_class)->gttp_pointset_set_priv_fset = __gttp_pointset_set_priv_fset;
	GTTP_POINTSET_CLASS(g_class)->gttp_pointset_get_priv_pointset = __gttp_pointset_get_priv_pointset;
	GTTP_POINTSET_CLASS(g_class)->gttp_pointset_get_priv_fset = __gttp_pointset_get_priv_fset;

	GTTP_POINTSET_CLASS(g_class)->instance_count = 0;

	g_type_class_add_private (g_class, sizeof (GTTPPointSetPrivate));
}


//void gttp_pointset_class_finalize(gpointer g_class, gpointer class_data)
//{
//
//}


static void gttp_pointset_instance_init(GTypeInstance *instance, gpointer g_class)
{

	GTTPPointSet *self;
	int paernt_iid;
	++gttppointset01_ct.instance_count;
	if(instance == NULL)
	{
		TRACE("%s The instance is NULL", __func__);
		gttppointset01_ct.instance_not_null = FALSE;
		return;
	}
	gttppointset01_ct.instance_not_null = TRUE;
	if(g_class == NULL)
	{
		TRACE("%s The g_class is NULL", __func__);
		gttppointset01_ct.class_not_null = FALSE;
		return;
	}
	gttppointset01_ct.class_not_null = TRUE;

	if(!GTTP_IS_FSET_CLASS(g_class))
	{
		TRACE("%s The local class type is not derived from FSET", __func__);
		gttppointset01_ct.local_class_type_is_valid = FALSE;
		return;
	}
	gttppointset01_ct.local_class_type_is_valid = TRUE;

	if(!GTTP_IS_FSET(instance))
	{
		TRACE("%s The local instance type is not derived from FSET", __func__);
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return;
	}
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
//Carefully initialize the expected class type otherwise error guaranteed.
	if(!G_TYPE_CHECK_CLASS_TYPE(g_class, gttppointset01_ct.expected_class_type))
	{
		TRACE("%s The current type is not expected", __func__);
		gttppointset01_ct.expected_class_type_is_valid = FALSE;
		return;
	}
	gttppointset01_ct.expected_class_type_is_valid = TRUE;

	if(!G_TYPE_FROM_INSTANCE(instance) == gttppointset01_ct.expected_class_type)
	{
		TRACE("%s The current instance type is not expected", __func__);
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return;
	}
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;

	self = GTTP_POINTSET(instance);
	if( self->instance_id != 0  ) {
		TRACE("%s The instance id is not 0", __func__);
		gttppointset01_ct.class_struct_zero_filled = FALSE;
		return;

	}
	gttppointset01_ct.class_struct_zero_filled = TRUE;


	paernt_iid = gttp_fset_get_instance_id(GTTP_FSET(self));
	if(paernt_iid < 1) {
		gttppointset01_ct.init_call_order_valid = FALSE;
	} else {
		gttppointset01_ct.init_call_order_valid = TRUE;
	}
    self->instance_id = gttppointset01_ct.instance_count;
	if(GTTP_POINTSET_GET_POINTSET_PRIVATE(self) == NULL) {
		gttppointset01_ct.private_init_is_done = FALSE;
		return;
	}
	gttppointset01_ct.private_init_is_done = TRUE;

}

//Class public method wrappers

gdouble gttp_pointset_distance(GTTPPointSet* self, GTTPPointSet* other_pointset)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return 0;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return 0;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return 0;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;

    return GTTP_POINTSET_GET_CLASS(self)->distance(self, other_pointset);
}

void gttp_pointset_translate(GTTPPointSet* self, int x, int y)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;


    GTTP_POINTSET_GET_CLASS(self)->translate(self, x, y);
}

int gttp_pointset_get_instance_count()
{
	int ic = 0;
	GTTPPointSetClass *p = g_type_class_ref(GTTP_TYPE_POINTSET);
	ic = p->get_instance_count();
	g_type_class_unref(p);
	return ic;
}

int gttp_pointset_get_instance_id(GTTPPointSet *self)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return -1;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return -1;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return -1;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;
	return GTTP_POINTSET_GET_CLASS(self)->get_instance_id(self);
}

gboolean gttp_pointset_get_init_order(GTTPPointSet *self) {
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return FALSE;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return FALSE;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return FALSE;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;
	return GTTP_POINTSET_GET_CLASS(self)->get_init_order(self);
}

GTTPPointSetPrivate * gttp_pointset_get_priv_pointset(GTTPPointSet *self)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return NULL;
	}
	gttppointset01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointset01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;

	return GTTP_POINTSET_GET_CLASS(self)->gttp_pointset_get_priv_pointset(self);
}

GTTPPointSetPrivate * gttp_pointset_get_priv_fset(GTTPPointSet *self)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return NULL;
	}
	gttppointset01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointset01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;

	return GTTP_POINTSET_GET_CLASS(self)->gttp_pointset_get_priv_fset(self);
}

void gttp_pointset_set_priv_pointset(GTTPPointSet *self, GTTPPointSetPrivate *svalue)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return;
	}
	gttppointset01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointset01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;

	GTTP_POINTSET_GET_CLASS(self)->gttp_pointset_set_priv_pointset(self, svalue);
}

void gttp_pointset_set_priv_fset(GTTPPointSet *self, GTTPPointSetPrivate *svalue)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return;
	}
	gttppointset01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointset01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;

	GTTP_POINTSET_GET_CLASS(self)->gttp_pointset_set_priv_fset(self, svalue);
}


//Class methods

static gdouble __gttp_pointset_distance(GTTPPointSet* self, GTTPPointSet* other_pointset)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return 0;
	}

	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return 0;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return 0;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;
    return 1.0;
}

static void __gttp_pointset_translate(GTTPPointSet* self, int x, int y)
{
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;

}


static int __get_instance_count()
{
	return gttppointset01_ct.instance_count;
}

static int __get_instance_id(GTTPPointSet *self) {
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return -1;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return -1;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return -1;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;
	return self->instance_id;
}

static gboolean __get_init_order(GTTPPointSet *self) {
	if(self == NULL)
	{
		gttppointset01_ct.instance_not_null = FALSE;
		return FALSE;
	}


	if(!GTTP_IS_FSET(self))
	{
		gttppointset01_ct.local_instance_type_is_valid = FALSE;
		return FALSE;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointset01_ct.expected_class_type)
	{
		gttppointset01_ct.expected_instance_type_is_valid = FALSE;
		return FALSE;
	}

	gttppointset01_ct.instance_not_null = TRUE;
	gttppointset01_ct.local_instance_type_is_valid = TRUE;
	gttppointset01_ct.expected_instance_type_is_valid = TRUE;
	return self->parnet_init_order;
}

static GTTPPointSetPrivate * __gttp_pointset_get_priv_pointset (GTTPPointSet *pset)
{
 	GTTPPointSetPrivate *priv = GTTP_POINTSET_GET_POINTSET_PRIVATE (pset);
 	return priv;
}

static GTTPPointSetPrivate * __gttp_pointset_get_priv_fset (GTTPPointSet *pset)
{
 	GTTPPointSetPrivate *priv = GTTP_POINTSET_GET_FSET_PRIVATE (pset);
 	return priv;
}

static void __gttp_pointset_set_priv_pointset (GTTPPointSet *pset, GTTPPointSetPrivate *svalue )
{
 	GTTPPointSetPrivate *priv = GTTP_POINTSET_GET_POINTSET_PRIVATE (pset);
 	memcpy(priv, svalue, sizeof(GTTPPointSetPrivate));
}

static void __gttp_pointset_set_priv_fset (GTTPPointSet *pset, GTTPPointSetPrivate *svalue )
{
 	GTTPPointSetPrivate *priv = GTTP_POINTSET_GET_FSET_PRIVATE (pset);
 	memcpy(priv, svalue, sizeof(GTTPPointSetPrivate));
}
