
#include "gttp-sortedpointlist.h"


static void gttp_sortedpointlist_base_init(gpointer g_class);
static void gttp_sortedpointlist_base_finalize(gpointer g_class);
static void gttp_sortedpointlist_class_init(gpointer g_class, gpointer class_data);
//static void gttp_sortedpointlist_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_sortedpointlist_instance_init(GTypeInstance *instance, gpointer g_class);

static gint default_compare_func(GTTPPoint* point1, GTTPPoint* point2);

static void __gttp_sortedpointlist_set_cmp_func(GTTPSortedPointList* self, GTTPPointCompare cmp_func);



GType gttp_type_sortedpointlist = 0;

GType register_gttp_sortedpointlist_type()
{

    if(gttp_type_sortedpointlist == 0)
    {
        gttp_type_sortedpointlist = test_register_gttp_sortedpointlist_type(GTTP_TYPE_POINTLIST,  "GTTPSortedPointList",
                        0, NULL);
    }

    return gttp_type_sortedpointlist;
}

GTypeInfo sortedpointlist_type_info;

GType test_register_gttp_sortedpointlist_type(GType parent_type, const gchar* type_name, GTypeFlags type_flags, const gpointer class_data)
{

    gboolean is_classed = G_TYPE_IS_CLASSED(parent_type);
    gboolean is_instantiable = is_classed && G_TYPE_IS_INSTANTIATABLE(parent_type);

    guint16 class_size = is_classed ? sizeof(GTTPSortedPointListClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_sortedpointlist_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_sortedpointlist_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_sortedpointlist_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = NULL;
    GInstanceInitFunc instance_init_func = is_instantiable ? gttp_sortedpointlist_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPSortedPointList) : 0;

//    GTypeInfo sortedpointlist_type_info = {
//        class_size,  /* class_size */
//        base_init_func,              /* base_init */
//        base_finalize_func,          /* base_destroy */
//        class_init_func,             /* class_init */
//        class_finalize_func,         /* class_destroy */
//        fclass_data,                  /* class_data */
//        instance_size,       /* instance_size */
//        0,                           /* n_preallocs */
//        instance_init_func,          /* instance_init */
//        NULL,                        /* value_table */
//    };

    sortedpointlist_type_info.class_size = class_size;
    sortedpointlist_type_info.base_init = base_init_func;
    sortedpointlist_type_info.base_finalize = base_finalize_func;
    sortedpointlist_type_info.class_init = class_init_func;
    sortedpointlist_type_info.class_finalize = class_finalize_func;
    sortedpointlist_type_info.class_data = fclass_data;
    sortedpointlist_type_info.instance_size = instance_size;
    sortedpointlist_type_info.n_preallocs = 0;
    sortedpointlist_type_info.instance_init = instance_init_func;
    sortedpointlist_type_info.value_table = NULL;



    GType t_gttp_type_sortedpointlist = g_type_register_static (parent_type,
                            type_name,
                            &sortedpointlist_type_info,
                            type_flags);



    return t_gttp_type_sortedpointlist;
}

//GTypeInfo methods

static void gttp_sortedpointlist_base_init(gpointer g_class)
{

}

static void gttp_sortedpointlist_base_finalize(gpointer g_class)
{

}

static void gttp_sortedpointlist_class_init(gpointer g_class, gpointer class_data)
{
    GTTP_SORTEDPOINTLIST_CLASS(g_class)->set_cmp_func = __gttp_sortedpointlist_set_cmp_func;
}

//static void gttp_sortedpointlist_class_finalize(gpointer g_class, gpointer class_data)
//{
//
//}

static void gttp_sortedpointlist_instance_init(GTypeInstance *instance, gpointer g_class)
{
    GTTP_SORTEDPOINTLIST(instance)->cmp_func = default_compare_func;
}




//Class public method wrappers

void gttp_sortedpointlist_set_cmp_func(GTTPSortedPointList* self, GTTPPointCompare cmp_func)
{
    GTTP_SORTEDPOINTLIST_GET_CLASS(self)->set_cmp_func(self, cmp_func);
}


//Class methods
static void __gttp_sortedpointlist_set_cmp_func(GTTPSortedPointList* self, GTTPPointCompare cmp_func)
{
    self->cmp_func = cmp_func;
}


static gint default_compare_func(GTTPPoint* point1, GTTPPoint* point2)
{
   if(point1->x < point2->x)
   {
        return -1;
   }
   else if(point1->x > point2->x)
   {
        return 1;
   }
   else
   {
        if(point1->y < point2->y)
        {
            return -1;
        }
        else if(point1->y > point2->y)
        {
            return 1;
        }
        else
        {
            return 0;
        }
   }
}
