#include "gttp-treemap.h"

#include <t2c.h>
extern int bVerbose;

static void gttp_treemap_base_init(gpointer g_class);
static void gttp_treemap_base_finalize(gpointer g_class);
static void gttp_treemap_class_init(gpointer g_class, gpointer class_data);
//static void gttp_treemap_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_treemap_instance_init(GTypeInstance *instance, gpointer g_class);

static void gttp_treemap_imap_interface_init (gpointer g_iface, gpointer iface_data);
static void gttp_treemap_imap_interface_finalize (gpointer g_iface, gpointer iface_data);

GType gttp_type_treemap_t;

GType register_gttp_treemap_type()
{
    static GType gttp_type_treemap = 0;
    if(gttp_type_treemap == 0)
    {

        if(gttp_type_treemap_t == 0)
        {
            gttp_type_treemap = test_register_gttp_treemap_type("GTTPTreeMap",
                                                 GTTP_TYPE_FMAP,
                                                 GTTP_TYPE_IMAP,
                                                 0, NULL, NULL);
        }else{
            gttp_type_treemap = gttp_type_treemap_t;
        }
    }
    return gttp_type_treemap;
}

GTypeInfo treemap_type_info;
GInterfaceInfo imap_ilist_info;

GType test_register_gttp_treemap_type(const gchar* type_name,
                                    GType parent_type,
                                    GType imap_iface_type,
                                    GTypeFlags type_flags,
                                    const gpointer class_data, const gpointer imap_iface_data)
{

    gboolean is_classed = G_TYPE_IS_CLASSED(parent_type);
    gboolean is_instantiable = is_classed && G_TYPE_IS_INSTANTIATABLE(parent_type);


    guint16 class_size = is_classed ? sizeof(GTTPTreeMapClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_treemap_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_treemap_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_treemap_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = NULL;
    GInstanceInitFunc instance_init_func = is_instantiable ? gttp_treemap_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPTreeMap) : 0;

    treemap_type_info.class_size = class_size;
    treemap_type_info.base_init = base_init_func;
    treemap_type_info.base_finalize = base_finalize_func;
    treemap_type_info.class_init = class_init_func;
    treemap_type_info.class_finalize = class_finalize_func;
    treemap_type_info.class_data = fclass_data;
    treemap_type_info.instance_size = instance_size;
    treemap_type_info.n_preallocs = 0;
    treemap_type_info.instance_init = instance_init_func;
    treemap_type_info.value_table = NULL;

    const gchar* ctype_name = type_name == NULL ? "GTTPTreeMap" : type_name;

    gttp_type_treemap_t = g_type_register_static (parent_type,
                                                        ctype_name,
                                                        &treemap_type_info,
                                                        type_flags);

    imap_ilist_info.interface_init = gttp_treemap_imap_interface_init;
    imap_ilist_info.interface_finalize = gttp_treemap_imap_interface_finalize;
    imap_ilist_info.interface_data = imap_iface_data;



    g_type_add_interface_static (gttp_type_treemap_t,
                                 imap_iface_type,
                                 &imap_ilist_info);


    return gttp_type_treemap_t;
}


// Class initialization methods

static void gttp_treemap_base_init(gpointer g_class)
{
    //TRACE("%s called", __func__)
    if(IS_USED_CT(gttptreemap_ct))
    {
        gttptreemap_ct.base_init_call_count++;

        if(gttptreemap_ct.base_init_call_count > gttptreemap_ct.exp_base_init_call_count)
        {
            TRACE("%s: GTypeInfo.base_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttptreemap_ct.base_init_call_count, gttptreemap_ct.exp_base_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttptreemap_ct.base_init_params_valid = FALSE;
            return;
        }

        if(G_TYPE_FROM_CLASS(g_class) != gttp_type_treemap_t)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttptreemap_ct.base_init_params_valid = FALSE;
            return;
        }

        if(!(GTTP_FMAP_CLASS(g_class)->field_long == FMAP_FIELD_LONG_INIT_VALUE &&
            GTTP_FMAP_CLASS(g_class)->field_bool == FMAP_FIELD_BOOL_INIT_VALUE &&
            GTTP_FMAP_CLASS(g_class)->field_ptr == (gpointer)FMAP_FIELD_PTR_INIT_VALUE))
        {
            TRACE("%s: GTypeInfo.base_init: the values of the fields of class structure were not copied from parent class.", __func__)
            gttptreemap_ct.class_struct_common_copied = FALSE;
            return;
        }

        gttptreemap_ct.class_struct_common_copied = TRUE;

        if(!(GTTP_TREEMAP_CLASS(g_class)->field_long == 0 &&
            GTTP_TREEMAP_CLASS(g_class)->field_int == 0 &&
            GTTP_TREEMAP_CLASS(g_class)->field_char == 0))
        {
            TRACE("%s: GTypeInfo.base_init: the remaining fields were not initialized.", __func__)
            gttptreemap_ct.class_struct_zero_filled = FALSE;
            return;
        }

        gttptreemap_ct.class_struct_zero_filled = TRUE;


        gttptreemap_ct.base_init_params_valid = TRUE;
        gttptreemap_ct.class_init_p_exp_class = g_class;
    }
}

static void gttp_treemap_base_finalize(gpointer g_class)
{

}


static void gttp_treemap_class_init(gpointer g_class, gpointer class_data)
{

    if(IS_USED_CT(gttptreemap_ct))
    {
        gttptreemap_ct.class_init_call_count++;

        if(gttptreemap_ct.base_init_call_count == 0)
        {
            TRACE("%s: GTypeInfo.class_init: class_init() callback is called earlier than base_init().",  __func__)
            gttptreemap_ct.init_call_order_valid = FALSE;
            return;
        }

        gttptreemap_ct.init_call_order_valid = TRUE;

        if(gttptreemap_ct.class_init_call_count > gttptreemap_ct.exp_class_init_call_count)
        {
            TRACE("%s: GTypeInfo.class_init: the callback was called %d times instead of expected %d times.", __func__,
                            gttptreemap_ct.class_init_call_count, gttptreemap_ct.exp_class_init_call_count);
            return;
        }

        if(g_class == NULL)
        {
            TRACE("%s: GTypeInfo.base_init: 'g_class' parameter passed in is NULL.", __func__);
            gttptreemap_ct.class_init_params_valid = FALSE;
            return;
        }

        if(gttptreemap_ct.class_init_p_exp_class != g_class)
        {
            TRACE("%s: GTypeInfo.base_init: invalid value passed in for the parameter 'g_class'.", __func__);
            gttptreemap_ct.class_init_params_valid = FALSE;
            return;
        }


        if(class_data != gttptreemap_ct.class_init_p_exp_class_data)
        {
            TRACE("%s: GTypeInfo.class_init: the 'gpointer class_data' parameter passed in does not have the expected value.", __func__)
            gttptreemap_ct.class_init_params_valid = FALSE;
            return;
        }


        gttptreemap_ct.class_init_params_valid = TRUE;
    }

}


//static void gttp_treemap_class_finalize(gpointer g_class, gpointer class_data)
//{
//
//}

//GInterfaceInfo methods

static void gttp_treemap_imap_interface_init (gpointer g_iface, gpointer iface_data)
{
    if(IS_USED_CT(gttptreemap_ct))
    {
        gttptreemap_ct.class_iface_init_call_count++;

//        TRACE("g_iface=%p;name=%s;imap_g_info=%p;fmap_g_class=%p", g_iface, g_type_name(G_TYPE_FROM_CLASS(g_iface)), gttpimap_ct.class_init_p_exp_class, gttptreemap_ct.iface_base_init_call_p_g_class);


        if(IS_USED_CT(gttpimap_ct))
        {
            if(gttpimap_ct.base_init_call_count < gttpimap_ct.exp_base_init_call_count)
            {
                TRACE("%s: GInterfaceInfo.interface_init: the registered callback was called before calling all the 'GTypeInfo.base_init' initialization functions of the implemented interface.", __func__);
                gttptreemap_ct.class_iface_init_call_order_valid = FALSE;
                return;
            }


            //This will be verified only if interface checklists are used and
            //thus 'iface_base_init_call_p_g_class' field is properly initialized.
            if(g_iface != gttptreemap_ct.iface_base_init_call_p_g_class )
            {
                TRACE("%s: GInterfaceInfo.interface_init: invalid vtable passed in as a parameter 'gpointer g_iface'.", __func__);
                gttptreemap_ct.class_iface_init_params_valid = FALSE;
                return;
            }

        }

        if(gttptreemap_ct.class_init_call_count == 0)
        {
            TRACE("%s: GInterfaceInfo.interface_init: the registered callback was called before calling all the 'GTypeInfo.class_init' initialization functions of the class.", __func__);
            gttptreemap_ct.class_iface_init_call_order_valid = FALSE;
            return;
        }

        gttptreemap_ct.class_iface_init_call_order_valid = TRUE;


        if(g_iface == NULL )
        {
            TRACE("%s: GInterfaceInfo.interface_init: NULL passed in for the parameter 'gpointer g_iface'.", __func__);
            gttptreemap_ct.class_iface_init_params_valid = FALSE;
            return;
        }

        if(G_TYPE_FROM_CLASS(g_iface) != GTTP_TYPE_IMAP)
        {
            TRACE("%s: GInterfaceInfo.interface_init: the vtable passed in for the parameter 'gpointer g_iface' is of invalid type.", __func__);
            gttptreemap_ct.class_iface_init_params_valid = FALSE;
            return;
        }


        if(iface_data != gttptreemap_ct.class_iface_init_p_exp_iface_data)
        {
            TRACE("%s: GInterfaceInfo.interface_init: invalid value passed in for the parameter 'gpointer iface_data'.", __func__);
            gttptreemap_ct.class_iface_init_params_valid = FALSE;
            return;
        }

        gttptreemap_ct.class_iface_init_params_valid = TRUE;


        if(gttptreemap_ct.icheck_handler_1_call_count > 0 ||
            gttptreemap_ct.icheck_handler_2_call_count > 0)
        {
            TRACE("%s: g_type_add_interface_check: interface check callback was called before 'GInterfaceInfo.interface_init' callback.", __func__);
            gttptreemap_ct.icheck_call_order_valid = FALSE;
            return;
        }

        gttptreemap_ct.icheck_call_order_valid = TRUE;
        gttptreemap_ct.exp_g_iface = g_iface;

    }
}

static void gttp_treemap_imap_interface_finalize (gpointer g_iface, gpointer iface_data)
{

}


//Instance initialization method

static void gttp_treemap_instance_init(GTypeInstance *instance, gpointer g_class)
{

}
