
#include <glib.h>
#include <glib-object.h>
//#include "gttp-fundamentals.h"

#ifndef FUNDAMENTAL_H_
#define FUNDAMENTAL_H_

//////////////

#ifndef GTTPFSET_H_
#define GTTPFSET_H_


#include <glib-object.h>
#include "gttp-fundamentals.h"

/*
 *
 * Fundamental type, representing a set of objects.
 *
 * This will be registered with various fundamental and
 * type flags.
 *
 */
#define GTTP_TYPE_FSTRING          (register_gttp_fstring_type())
#define GTTP_TYPE_FSTRING_NAME			 "GTTPFString"
#define GTTP_FSTRING_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_FSTRING, GTTPFSetClass))
#define GTTP_IS_FSTRING_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_FSTRING))


typedef struct _GTTPFString    GTTPFString;
typedef struct _GTTPFStringClass GTTPFStringClass;


struct _GTTPFString{
  GTypeInstance parent;
  gint element_count;
  gpointer* elements;
  int ic;
};

struct _GTTPFStringClass{
    GTypeClass parent_class;

   /* void (*add)(GTTPFString* set_object, gpointer element);
    void (*remove)(GTTPFString* set_object, gpointer element);
    gint (*size)(GTTPFString* set_object);
    int (*get_instance_count)();
   	int (*get_instance_id)(GTTPFString* self);*/
};

//Very specific type registration function, to register this fundamental type
// with different combination of flags.
GType register_gttp_fstring_type();
GType test_register_gttp_fstring_type(const gchar* type_name, GTypeFundamentalFlags fundamental_flags, GTypeFlags type_flags, const gpointer class_data,const GTypeValueTable* value_table);
/*
void gttp_fset_add(GTTPFString* set_object, gpointer element);
void gttp_fset_remove(GTTPFString* set_object, gpointer element);
gint gttp_fset_size(GTTPFString* set_object);*/
#endif /*GTTPFCOMPLEX_H_*/
///////////////





//global variables for determining callback functions call count
 int value_init_call_count;
 int value_free_call_count;
 int value_copy_call_count;
 int value_collect_call_count;
 int value_lcopy_call_count;
 int value_peek_pointer_call_count;

/* functions prototypes */
//
//Integer

void   my_value_init_int (GValue *value);
void   my_value_copy_int (const GValue *src_value,GValue* dest_value);
gchar* my_value_collect_int (GValue *value,guint n_collect_values, GTypeCValue *collect_values, guint collect_flags);
gchar* my_value_lcopy_int   (const GValue *value,guint n_collect_values,GTypeCValue  *collect_values, guint  collect_flags);

//String

void my_value_init_string (GValue *value);
void my_value_free_string (GValue *value);
void my_value_copy_string (const GValue *src_value, GValue	*dest_value);
gchar* my_value_collect_string (GValue  *value,guint  n_collect_values,GTypeCValue *collect_values, guint collect_flags);
gchar* my_value_lcopy_string (const GValue *value,guint n_collect_values,GTypeCValue  *collect_values, guint collect_flags);
gpointer my_value_peek_pointer (const GValue *value);



// fundamental info
static const GTypeFundamentalInfo FundStringInfo = { G_TYPE_FLAG_DERIVABLE , };
static const GTypeFundamentalInfo FundIntInfo = { G_TYPE_FLAG_DERIVABLE , };
static const GTypeFundamentalInfo FundEmptyInfo = { G_TYPE_FLAG_DERIVABLE , };


// int value table
static const GTypeValueTable my_int_value_table = {
  my_value_init_int,	/* value_init */
  NULL,			        /* value_free */
  my_value_copy_int,	/* value_copy */
  NULL,			        /* value_peek_pointer */
  "i",			        /* collect_format */
  my_value_collect_int,	/* collect_value */
  "p",			        /* lcopy_format */
  my_value_lcopy_int,   /* lcopy_value */
};

static const GTypeValueTable my_string_value_table = {
     my_value_init_string,	/* value_init */
     my_value_free_string,	/* value_free */
     my_value_copy_string,	/* value_copy */
     my_value_peek_pointer,	/* value_peek_pointer */
     "p",						/* collect_format */
     my_value_collect_string,	/* collect_value */
     "p",						/* lcopy_format */
     my_value_lcopy_string,	/* lcopy_value */
    };


// type info for Integer fundamental type
static const GTypeInfo 							IntInfo = {
    0,								/* class_size */
    NULL,							/* base_init */
    NULL,							/* base_destroy */
    NULL,							/* class_init */
    NULL,							/* class_destroy */
    NULL,							/* class_data */
    0,								/* instance_size */
    0,								/* n_preallocs */
    NULL,							/* instance_init */
    &my_int_value_table,			/* value_table */
  };

// type info for String fundamental type
static const GTypeInfo 							StringInfo = {
    0,								/* class_size */
    NULL,							/* base_init */
    NULL,							/* base_destroy */
    NULL,							/* class_init */
    NULL,							/* class_destroy */
    NULL,							/* class_data */
    0,								/* instance_size */
    0,								/* n_preallocs */
    NULL,							/* instance_init */
    &my_string_value_table,			/* value_table */
  };


// type info without GTypeValueTable
static const GTypeInfo 							EmptyInfo = {
    0,								/* class_size */
    NULL,							/* base_init */
    NULL,							/* base_destroy */
    NULL,							/* class_init */
    NULL,							/* class_destroy */
    NULL,							/* class_data */
    0,								/* instance_size */
    0,								/* n_preallocs */
    NULL,							/* instance_init */
    NULL,							/* value_table */
  };

//Type create functions
GType  get_my_int_type();
GType  get_my_string_type();
GType  get_empty_type();
#endif /*FUNDAMENTAL_H_*/
