
#include <string.h>
#include "gttp-fundamentals.h"
#include <glib.h>
#include <glib-object.h>


//////////////////////////////////////////////////////////////////

#include <t2c.h>
extern int bVerbose;


GType register_gttp_fstring_type()
{
	static int gttp_type_fstring = 0;
    if(gttp_type_fstring == 0)
    {
        gttp_type_fstring = test_register_gttp_fstring_type(GTTP_TYPE_FSTRING_NAME,
        										 G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE |
        										 G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE,
        										 0, NULL,&my_string_value_table);
    }
    return gttp_type_fstring;
}

GType test_register_gttp_fstring_type(const gchar* type_name, GTypeFundamentalFlags fundamental_flags, GTypeFlags type_flags, const gpointer class_data,const GTypeValueTable* value_table)
{

    gboolean is_classed = (fundamental_flags & G_TYPE_FLAG_CLASSED) == G_TYPE_FLAG_CLASSED;
    gboolean is_instantiable = is_classed && (fundamental_flags & G_TYPE_FLAG_INSTANTIATABLE) == G_TYPE_FLAG_INSTANTIATABLE;

    GType next_ftypeid = g_type_fundamental_next();

    GTypeFundamentalInfo fndtype_info = {fundamental_flags};

    guint16 class_size = is_classed ? sizeof(GTTPFStringClass) : 0;
    guint16 instance_size = is_instantiable ? sizeof(GTTPFString) : 0;


GTypeInfo fset_type_info = {
        class_size,                 /* class_size */
        NULL,             			/* base_init */
        NULL,         				/* base_destroy */
        NULL,            			/* class_init */
        NULL,        				/* class_destroy */
        NULL,                		/* class_data */
        instance_size,              /* instance_size */
        0,                          /* n_preallocs */
        NULL,       				/* instance_init */
        value_table,                /* value_table */
    };

    GType t_gttp_type_fset = g_type_register_fundamental(
                                next_ftypeid,
                                type_name,
                                &fset_type_info,
                                &fndtype_info,
                                type_flags);


    return t_gttp_type_fset;
}






//
//Create Int Type
GType  get_my_int_type()
{
	static GType my_int_type=0;
	if(!my_int_type)
	{
		GType type=g_type_fundamental_next();
	 	my_int_type=g_type_register_fundamental ( type,"MY-INT", &IntInfo,&FundIntInfo,0);
	}
	return my_int_type;
}

//
//Create String Type

GType  get_my_string_type()
{
	static GType my_string_type=0;
	if(!my_string_type)
	{
		GType type=g_type_fundamental_next();
	 	my_string_type=g_type_register_fundamental ( type,"MY-STRING", &StringInfo,&FundStringInfo,0);
	}
	return my_string_type;
}



//
// Create Empty Type
GType  get_empty_type()
{
	static GType empty_type=0;
	if(!empty_type)
	{
		GType type=g_type_fundamental_next();
		empty_type= g_type_register_fundamental ( type,"MY-EMPTY", &EmptyInfo,&FundEmptyInfo,0);
		//empty_type= g_type_register_static (G_TYPE_OBJECT,"Empty",&EmptyInfo,0);

	}
	return empty_type;
}

/////////int type

void my_value_init_int (GValue *value)
{
	value->data[0].v_int = -1;
	value_init_call_count++;
}



void   my_value_copy_int (const GValue *src_value,GValue* dest_value)
{
	 dest_value->data[0].v_int = src_value->data[0].v_int;
	 value_copy_call_count++;
}

gchar* my_value_collect_int (GValue *value,guint n_collect_values, GTypeCValue *collect_values, guint collect_flags)
{
	value_collect_call_count++;
	return NULL;
}


gchar* my_value_lcopy_int   (const GValue *value,guint n_collect_values,GTypeCValue  *collect_values, guint  collect_flags)
{

    value_lcopy_call_count++;
  	return NULL;
}


////////String type

void my_value_init_string (GValue *value)
{
  value->data[0].v_pointer = NULL;
}

void my_value_free_string (GValue *value)
{
  value_free_call_count++;
  if (!(value->data[1].v_uint & G_VALUE_NOCOPY_CONTENTS))
    g_free (value->data[0].v_pointer);
}

void my_value_copy_string (const GValue *src_value,  GValue	*dest_value)
{
  dest_value->data[0].v_pointer = g_strdup (src_value->data[0].v_pointer);
}

gchar* my_value_collect_string (GValue  *value,guint  n_collect_values,GTypeCValue *collect_values, guint collect_flags)
{
  value_collect_call_count++;
  return NULL;
}

gchar* my_value_lcopy_string (const GValue *value,guint n_collect_values,GTypeCValue  *collect_values, guint collect_flags)
{

  return NULL;
}

gpointer my_value_peek_pointer (const GValue *value)
{
  value_peek_pointer_call_count++;
  return value->data[0].v_pointer;

}

